(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@antv/g'), require('mana-syringe')) :
  typeof define === 'function' && define.amd ? define(['exports', '@antv/g', 'mana-syringe'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.G = global.G || {}, global.G.SVG = {}), global.window.G, global.window.G.ManaSyringe));
}(this, (function (exports, g, manaSyringe) { 'use strict';

  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;

    _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  /******************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */

  function __decorate(decorators, target, key, desc) {
      var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
      else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
      return c > 3 && r && Object.defineProperty(target, key, r), r;
  }

  function __metadata(metadataKey, metadataValue) {
      if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
  }

  function _regeneratorRuntime() {
    /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */
    _regeneratorRuntime = function _regeneratorRuntime() {
      return exports;
    };

    var exports = {},
        Op = Object.prototype,
        hasOwn = Op.hasOwnProperty,
        $Symbol = "function" == typeof Symbol ? Symbol : {},
        iteratorSymbol = $Symbol.iterator || "@@iterator",
        asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
        toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      return Object.defineProperty(obj, key, {
        value: value,
        enumerable: !0,
        configurable: !0,
        writable: !0
      }), obj[key];
    }

    try {
      define({}, "");
    } catch (err) {
      define = function define(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
          generator = Object.create(protoGenerator.prototype),
          context = new Context(tryLocsList || []);
      return generator._invoke = function (innerFn, self, context) {
        var state = "suspendedStart";
        return function (method, arg) {
          if ("executing" === state) throw new Error("Generator is already running");

          if ("completed" === state) {
            if ("throw" === method) throw arg;
            return doneResult();
          }

          for (context.method = method, context.arg = arg;;) {
            var delegate = context.delegate;

            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context);

              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue;
                return delegateResult;
              }
            }

            if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
              if ("suspendedStart" === state) throw state = "completed", context.arg;
              context.dispatchException(context.arg);
            } else "return" === context.method && context.abrupt("return", context.arg);
            state = "executing";
            var record = tryCatch(innerFn, self, context);

            if ("normal" === record.type) {
              if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
              return {
                value: record.arg,
                done: context.done
              };
            }

            "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
          }
        };
      }(innerFn, self, context), generator;
    }

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    exports.wrap = wrap;
    var ContinueSentinel = {};

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {}

    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });
    var getProto = Object.getPrototypeOf,
        NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if ("throw" !== record.type) {
          var result = record.arg,
              value = result.value;
          return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          }) : PromiseImpl.resolve(value).then(function (unwrapped) {
            result.value = unwrapped, resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }

        reject(record.arg);
      }

      var previousPromise;

      this._invoke = function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      };
    }

    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (undefined === method) {
        if (context.delegate = null, "throw" === context.method) {
          if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
          context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);
      if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
      var info = record.arg;
      return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
    }

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };
      1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal", delete record.arg, entry.completion = record;
    }

    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
    }

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) return iteratorMethod.call(iterable);
        if ("function" == typeof iterable.next) return iterable;

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            for (; ++i < iterable.length;) {
              if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            }

            return next.value = undefined, next.done = !0, next;
          };

          return next.next = next;
        }
      }

      return {
        next: doneResult
      };
    }

    function doneResult() {
      return {
        value: undefined,
        done: !0
      };
    }

    return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
      var ctor = "function" == typeof genFun && genFun.constructor;
      return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
    }, exports.mark = function (genFun) {
      return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
    }, exports.awrap = function (arg) {
      return {
        __await: arg
      };
    }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      void 0 === PromiseImpl && (PromiseImpl = Promise);
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
      return this;
    }), define(Gp, "toString", function () {
      return "[object Generator]";
    }), exports.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      return keys.reverse(), function next() {
        for (; keys.length;) {
          var key = keys.pop();
          if (key in object) return next.value = key, next.done = !1, next;
        }

        return next.done = !0, next;
      };
    }, exports.values = values, Context.prototype = {
      constructor: Context,
      reset: function reset(skipTempReset) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) {
          "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
        }
      },
      stop: function stop() {
        this.done = !0;
        var rootRecord = this.tryEntries[0].completion;
        if ("throw" === rootRecord.type) throw rootRecord.arg;
        return this.rval;
      },
      dispatchException: function dispatchException(exception) {
        if (this.done) throw exception;
        var context = this;

        function handle(loc, caught) {
          return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i],
              record = entry.completion;
          if ("root" === entry.tryLoc) return handle("end");

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc"),
                hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            } else {
              if (!hasFinally) throw new Error("try statement without catch or finally");
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            }
          }
        }
      },
      abrupt: function abrupt(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
        var record = finallyEntry ? finallyEntry.completion : {};
        return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
      },
      complete: function complete(record, afterLoc) {
        if ("throw" === record.type) throw record.arg;
        return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
      },
      finish: function finish(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
        }
      },
      catch: function _catch(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if ("throw" === record.type) {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        }

        throw new Error("illegal catch attempt");
      },
      delegateYield: function delegateYield(iterable, resultName, nextLoc) {
        return this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
      }
    }, exports;
  }

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  var _class;

  var DOMInteractionPlugin_1;
  var MOBILE_REGEX = /mobile|tablet|ip(ad|hone|od)|android/i;
  /**
   * listen to mouse/touch/pointer events on DOM wrapper, trigger pointer events
   */

  var DOMInteractionPlugin = DOMInteractionPlugin_1 = (_class = /*#__PURE__*/function () {
    function DOMInteractionPlugin() {
      this.contextService = void 0;
      this.renderingContext = void 0;
    }

    var _proto = DOMInteractionPlugin.prototype;

    _proto.apply = function apply(renderingService) {
      var _this = this;

      var canvas = this.renderingContext.root.ownerDocument.defaultView;
      var SUPPORT_ONLY_TOUCH = canvas.supportsTouchEvents && MOBILE_REGEX.test(navigator.userAgent);

      var onPointerMove = function onPointerMove(ev) {
        renderingService.hooks.pointerMove.call(ev);
      };

      var onPointerUp = function onPointerUp(ev) {
        renderingService.hooks.pointerUp.call(ev);
      };

      var onPointerDown = function onPointerDown(ev) {
        renderingService.hooks.pointerDown.call(ev);
      };

      var onPointerOver = function onPointerOver(ev) {
        renderingService.hooks.pointerOver.call(ev);
      };

      var onPointerOut = function onPointerOut(ev) {
        renderingService.hooks.pointerOut.call(ev);
      };

      var onPointerCancel = function onPointerCancel(ev) {
        renderingService.hooks.pointerCancel.call(ev);
      };

      var onPointerWheel = function onPointerWheel(ev) {
        renderingService.hooks.pointerWheel.call(ev);
      };

      var addPointerEventListener = function addPointerEventListener($el) {
        globalThis.document.addEventListener('pointermove', onPointerMove, true);
        $el.addEventListener('pointerdown', onPointerDown, true);
        $el.addEventListener('pointerleave', onPointerOut, true);
        $el.addEventListener('pointerover', onPointerOver, true);
        globalThis.addEventListener('pointerup', onPointerUp, true);
      };

      var addTouchEventListener = function addTouchEventListener($el) {
        $el.addEventListener('touchstart', onPointerDown, true);
        $el.addEventListener('touchend', onPointerUp, true);
        $el.addEventListener('touchmove', onPointerMove, true);
        $el.addEventListener('touchcancel', onPointerCancel, true);
      };

      var addMouseEventListener = function addMouseEventListener($el) {
        globalThis.document.addEventListener('mousemove', onPointerMove, true);
        $el.addEventListener('mousedown', onPointerDown, true);
        $el.addEventListener('mouseout', onPointerOut, true);
        $el.addEventListener('mouseover', onPointerOver, true);
        globalThis.addEventListener('mouseup', onPointerUp, true);
      };

      var removePointerEventListener = function removePointerEventListener($el) {
        globalThis.document.removeEventListener('pointermove', onPointerMove, true);
        $el.removeEventListener('pointerdown', onPointerDown, true);
        $el.removeEventListener('pointerleave', onPointerOut, true);
        $el.removeEventListener('pointerover', onPointerOver, true);
        globalThis.removeEventListener('pointerup', onPointerUp, true);
      };

      var removeTouchEventListener = function removeTouchEventListener($el) {
        $el.removeEventListener('touchstart', onPointerDown, true);
        $el.removeEventListener('touchend', onPointerUp, true);
        $el.removeEventListener('touchmove', onPointerMove, true);
      };

      var removeMouseEventListener = function removeMouseEventListener($el) {
        globalThis.document.removeEventListener('mousemove', onPointerMove, true);
        $el.removeEventListener('mousedown', onPointerDown, true);
        $el.removeEventListener('mouseout', onPointerOut, true);
        $el.removeEventListener('mouseover', onPointerOver, true);
        globalThis.removeEventListener('mouseup', onPointerUp, true);
      };

      renderingService.hooks.init.tapPromise(DOMInteractionPlugin_1.tag, /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        var $el;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                $el = _this.contextService.getDomElement(); // @ts-ignore

                if (globalThis.navigator.msPointerEnabled) {
                  // @ts-ignore
                  $el.style.msContentZooming = 'none'; // @ts-ignore

                  $el.style.msTouchAction = 'none';
                } else if (canvas.supportsPointerEvents) {
                  $el.style.touchAction = 'none';
                }

                if (canvas.supportsPointerEvents) {
                  addPointerEventListener($el);
                } else {
                  addMouseEventListener($el);
                }

                if (canvas.supportsTouchEvents) {
                  addTouchEventListener($el);
                } // use passive event listeners
                // @see https://zhuanlan.zhihu.com/p/24555031


                $el.addEventListener('wheel', onPointerWheel, {
                  passive: true,
                  capture: true
                });

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      })));
      renderingService.hooks.destroy.tap(DOMInteractionPlugin_1.tag, function () {
        var $el = _this.contextService.getDomElement();

        if (canvas.supportsPointerEvents) {
          removePointerEventListener($el);
        } else {
          removeMouseEventListener($el);
        }

        if (canvas.supportsTouchEvents) {
          removeTouchEventListener($el);
        }

        $el.removeEventListener('wheel', onPointerWheel, true);
      });
    };

    return DOMInteractionPlugin;
  }(), _class.tag = 'DOMInteraction', _class);

  __decorate([manaSyringe.inject(g.ContextService), __metadata("design:type", Object)], DOMInteractionPlugin.prototype, "contextService", void 0);

  __decorate([manaSyringe.inject(g.RenderingContext), __metadata("design:type", Object)], DOMInteractionPlugin.prototype, "renderingContext", void 0);

  DOMInteractionPlugin = DOMInteractionPlugin_1 = __decorate([manaSyringe.singleton({
    contrib: g.RenderingPluginContribution
  })], DOMInteractionPlugin);
  var containerModule = manaSyringe.Module(function (register) {
    register(DOMInteractionPlugin);
  });

  var Plugin = /*#__PURE__*/function () {
    function Plugin() {
      this.name = 'dom-interaction';
    }

    var _proto = Plugin.prototype;

    _proto.init = function init(container) {
      container.load(containerModule, true);
    };

    _proto.destroy = function destroy(container) {
      container.unload(containerModule);
    };

    return Plugin;
  }();

  var index_esm = /*#__PURE__*/Object.freeze({
    __proto__: null,
    Plugin: Plugin
  });

  var __spreadArray = (undefined && undefined.__spreadArray) || function (to, from, pack) {
      if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
          if (ar || !(i in from)) {
              if (!ar) ar = Array.prototype.slice.call(from, 0, i);
              ar[i] = from[i];
          }
      }
      return to.concat(ar || Array.prototype.slice.call(from));
  };
  var BrowserInfo = /** @class */ (function () {
      function BrowserInfo(name, version, os) {
          this.name = name;
          this.version = version;
          this.os = os;
          this.type = 'browser';
      }
      return BrowserInfo;
  }());
  var NodeInfo = /** @class */ (function () {
      function NodeInfo(version) {
          this.version = version;
          this.type = 'node';
          this.name = 'node';
          this.os = process.platform;
      }
      return NodeInfo;
  }());
  var SearchBotDeviceInfo = /** @class */ (function () {
      function SearchBotDeviceInfo(name, version, os, bot) {
          this.name = name;
          this.version = version;
          this.os = os;
          this.bot = bot;
          this.type = 'bot-device';
      }
      return SearchBotDeviceInfo;
  }());
  var BotInfo = /** @class */ (function () {
      function BotInfo() {
          this.type = 'bot';
          this.bot = true; // NOTE: deprecated test name instead
          this.name = 'bot';
          this.version = null;
          this.os = null;
      }
      return BotInfo;
  }());
  var ReactNativeInfo = /** @class */ (function () {
      function ReactNativeInfo() {
          this.type = 'react-native';
          this.name = 'react-native';
          this.version = null;
          this.os = null;
      }
      return ReactNativeInfo;
  }());
  // tslint:disable-next-line:max-line-length
  var SEARCHBOX_UA_REGEX = /alexa|bot|crawl(er|ing)|facebookexternalhit|feedburner|google web preview|nagios|postrank|pingdom|slurp|spider|yahoo!|yandex/;
  var SEARCHBOT_OS_REGEX = /(nuhk|curl|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask\ Jeeves\/Teoma|ia_archiver)/;
  var REQUIRED_VERSION_PARTS = 3;
  var userAgentRules = [
      ['aol', /AOLShield\/([0-9\._]+)/],
      ['edge', /Edge\/([0-9\._]+)/],
      ['edge-ios', /EdgiOS\/([0-9\._]+)/],
      ['yandexbrowser', /YaBrowser\/([0-9\._]+)/],
      ['kakaotalk', /KAKAOTALK\s([0-9\.]+)/],
      ['samsung', /SamsungBrowser\/([0-9\.]+)/],
      ['silk', /\bSilk\/([0-9._-]+)\b/],
      ['miui', /MiuiBrowser\/([0-9\.]+)$/],
      ['beaker', /BeakerBrowser\/([0-9\.]+)/],
      ['edge-chromium', /EdgA?\/([0-9\.]+)/],
      [
          'chromium-webview',
          /(?!Chrom.*OPR)wv\).*Chrom(?:e|ium)\/([0-9\.]+)(:?\s|$)/,
      ],
      ['chrome', /(?!Chrom.*OPR)Chrom(?:e|ium)\/([0-9\.]+)(:?\s|$)/],
      ['phantomjs', /PhantomJS\/([0-9\.]+)(:?\s|$)/],
      ['crios', /CriOS\/([0-9\.]+)(:?\s|$)/],
      ['firefox', /Firefox\/([0-9\.]+)(?:\s|$)/],
      ['fxios', /FxiOS\/([0-9\.]+)/],
      ['opera-mini', /Opera Mini.*Version\/([0-9\.]+)/],
      ['opera', /Opera\/([0-9\.]+)(?:\s|$)/],
      ['opera', /OPR\/([0-9\.]+)(:?\s|$)/],
      ['pie', /^Microsoft Pocket Internet Explorer\/(\d+\.\d+)$/],
      ['pie', /^Mozilla\/\d\.\d+\s\(compatible;\s(?:MSP?IE|MSInternet Explorer) (\d+\.\d+);.*Windows CE.*\)$/],
      ['netfront', /^Mozilla\/\d\.\d+.*NetFront\/(\d.\d)/],
      ['ie', /Trident\/7\.0.*rv\:([0-9\.]+).*\).*Gecko$/],
      ['ie', /MSIE\s([0-9\.]+);.*Trident\/[4-7].0/],
      ['ie', /MSIE\s(7\.0)/],
      ['bb10', /BB10;\sTouch.*Version\/([0-9\.]+)/],
      ['android', /Android\s([0-9\.]+)/],
      ['ios', /Version\/([0-9\._]+).*Mobile.*Safari.*/],
      ['safari', /Version\/([0-9\._]+).*Safari/],
      ['facebook', /FB[AS]V\/([0-9\.]+)/],
      ['instagram', /Instagram\s([0-9\.]+)/],
      ['ios-webview', /AppleWebKit\/([0-9\.]+).*Mobile/],
      ['ios-webview', /AppleWebKit\/([0-9\.]+).*Gecko\)$/],
      ['curl', /^curl\/([0-9\.]+)$/],
      ['searchbot', SEARCHBOX_UA_REGEX],
  ];
  var operatingSystemRules = [
      ['iOS', /iP(hone|od|ad)/],
      ['Android OS', /Android/],
      ['BlackBerry OS', /BlackBerry|BB10/],
      ['Windows Mobile', /IEMobile/],
      ['Amazon OS', /Kindle/],
      ['Windows 3.11', /Win16/],
      ['Windows 95', /(Windows 95)|(Win95)|(Windows_95)/],
      ['Windows 98', /(Windows 98)|(Win98)/],
      ['Windows 2000', /(Windows NT 5.0)|(Windows 2000)/],
      ['Windows XP', /(Windows NT 5.1)|(Windows XP)/],
      ['Windows Server 2003', /(Windows NT 5.2)/],
      ['Windows Vista', /(Windows NT 6.0)/],
      ['Windows 7', /(Windows NT 6.1)/],
      ['Windows 8', /(Windows NT 6.2)/],
      ['Windows 8.1', /(Windows NT 6.3)/],
      ['Windows 10', /(Windows NT 10.0)/],
      ['Windows ME', /Windows ME/],
      ['Windows CE', /Windows CE|WinCE|Microsoft Pocket Internet Explorer/],
      ['Open BSD', /OpenBSD/],
      ['Sun OS', /SunOS/],
      ['Chrome OS', /CrOS/],
      ['Linux', /(Linux)|(X11)/],
      ['Mac OS', /(Mac_PowerPC)|(Macintosh)/],
      ['QNX', /QNX/],
      ['BeOS', /BeOS/],
      ['OS/2', /OS\/2/],
  ];
  function detect(userAgent) {
      if (!!userAgent) {
          return parseUserAgent(userAgent);
      }
      if (typeof document === 'undefined' &&
          typeof navigator !== 'undefined' &&
          navigator.product === 'ReactNative') {
          return new ReactNativeInfo();
      }
      if (typeof navigator !== 'undefined') {
          return parseUserAgent(navigator.userAgent);
      }
      return getNodeVersion();
  }
  function matchUserAgent(ua) {
      // opted for using reduce here rather than Array#first with a regex.test call
      // this is primarily because using the reduce we only perform the regex
      // execution once rather than once for the test and for the exec again below
      // probably something that needs to be benchmarked though
      return (ua !== '' &&
          userAgentRules.reduce(function (matched, _a) {
              var browser = _a[0], regex = _a[1];
              if (matched) {
                  return matched;
              }
              var uaMatch = regex.exec(ua);
              return !!uaMatch && [browser, uaMatch];
          }, false));
  }
  function parseUserAgent(ua) {
      var matchedRule = matchUserAgent(ua);
      if (!matchedRule) {
          return null;
      }
      var name = matchedRule[0], match = matchedRule[1];
      if (name === 'searchbot') {
          return new BotInfo();
      }
      // Do not use RegExp for split operation as some browser do not support it (See: http://blog.stevenlevithan.com/archives/cross-browser-split)
      var versionParts = match[1] && match[1].split('.').join('_').split('_').slice(0, 3);
      if (versionParts) {
          if (versionParts.length < REQUIRED_VERSION_PARTS) {
              versionParts = __spreadArray(__spreadArray([], versionParts, true), createVersionParts(REQUIRED_VERSION_PARTS - versionParts.length), true);
          }
      }
      else {
          versionParts = [];
      }
      var version = versionParts.join('.');
      var os = detectOS(ua);
      var searchBotMatch = SEARCHBOT_OS_REGEX.exec(ua);
      if (searchBotMatch && searchBotMatch[1]) {
          return new SearchBotDeviceInfo(name, version, os, searchBotMatch[1]);
      }
      return new BrowserInfo(name, version, os);
  }
  function detectOS(ua) {
      for (var ii = 0, count = operatingSystemRules.length; ii < count; ii++) {
          var _a = operatingSystemRules[ii], os = _a[0], regex = _a[1];
          var match = regex.exec(ua);
          if (match) {
              return os;
          }
      }
      return null;
  }
  function getNodeVersion() {
      var isNode = typeof process !== 'undefined' && process.version;
      return isNode ? new NodeInfo(process.version.slice(1)) : null;
  }
  function createVersionParts(count) {
      var output = [];
      for (var ii = 0; ii < count; ii++) {
          output.push('0');
      }
      return output;
  }

  var ElementSVG = function ElementSVG() {
    this.$el = void 0;
    this.$groupEl = void 0;
    this.$hitTestingEl = void 0;
  };

  ElementSVG.tag = 'c-svg-element';

  var RectRenderer = /*#__PURE__*/function () {
    function RectRenderer() {
      this.dependencies = ['radius', 'width', 'height'];
    }

    var _proto = RectRenderer.prototype;

    _proto.apply = function apply($el, parsedStyle) {
      var radius = parsedStyle.radius,
          width = parsedStyle.width,
          height = parsedStyle.height;
      var hasRadius = radius && radius.some(function (r) {
        return r.value !== 0;
      });
      var d = '';

      if (!hasRadius) {
        d = "M 0,0 l " + width.value + ",0 l 0," + height.value + " l" + -width.value + " 0 z";
      } else {
        var _radius$map = radius.map(function (r) {
          return r.value;
        }),
            tlr = _radius$map[0],
            trr = _radius$map[1],
            brr = _radius$map[2],
            blr = _radius$map[3];

        d = [["M " + tlr + ",0"], ["l " + (width.value - tlr - trr) + ",0"], ["a " + trr + "," + trr + ",0,0,1," + trr + "," + trr], ["l 0," + (height.value - trr - brr)], ["a " + brr + "," + brr + ",0,0,1," + -brr + "," + brr], ["l " + (brr + blr - width.value) + ",0"], ["a " + blr + "," + blr + ",0,0,1," + -blr + "," + -blr], ["l 0," + (blr + tlr - height.value)], ["a " + tlr + "," + tlr + ",0,0,1," + tlr + "," + -tlr], ['z']].join(' ');
      }

      $el.setAttribute('d', d);
    };

    return RectRenderer;
  }();

  RectRenderer = __decorate([manaSyringe.singleton()], RectRenderer);

  var ImageRenderer = /*#__PURE__*/function () {
    function ImageRenderer() {
      this.dependencies = ['img', 'width', 'height'];
    }

    var _proto = ImageRenderer.prototype;

    _proto.apply = function apply($el, parsedStyle) {
      var _parsedStyle$img = parsedStyle.img,
          img = _parsedStyle$img === void 0 ? '' : _parsedStyle$img,
          width = parsedStyle.width,
          height = parsedStyle.height;
      $el.setAttribute('x', '0');
      $el.setAttribute('y', '0');

      if (g.isString(img)) {
        $el.setAttribute('href', img);
      } else if (img instanceof Image) {
        if (!width) {
          $el.setAttribute('width', "" + img.width); // TODO: set renderable.boundsDirty
          // this.attr('width', img.width);
        }

        if (!height) {
          $el.setAttribute('height', "" + img.height); // this.attr('height', img.height);
        }

        $el.setAttribute('href', img.src);
      } else if ( // @ts-ignore
      img instanceof HTMLElement && g.isString(img.nodeName) && img.nodeName.toUpperCase() === 'CANVAS') {
        $el.setAttribute('href', img.toDataURL()); // @ts-ignore
      } else if (img instanceof ImageData) {
        var canvas = document.createElement('canvas'); // @ts-ignore

        canvas.setAttribute('width', "" + img.width); // @ts-ignore

        canvas.setAttribute('height', "" + img.height);
        var context = canvas.getContext('2d');

        if (context) {
          context.putImageData(img, 0, 0);

          if (!width) {
            // @ts-ignore
            $el.setAttribute('width', "" + img.width); // this.attr('width', img.width);
          }

          if (!height) {
            // @ts-ignore
            $el.setAttribute('height', "" + img.height); // this.attr('height', img.height);
          }

          $el.setAttribute('href', canvas.toDataURL());
        }
      }
    };

    return ImageRenderer;
  }();

  ImageRenderer = __decorate([manaSyringe.singleton()], ImageRenderer);

  var LineRenderer = /*#__PURE__*/function () {
    function LineRenderer() {
      this.dependencies = ['x1', 'y1', 'x2', 'y2'];
    }

    var _proto = LineRenderer.prototype;

    _proto.apply = function apply($el, parsedStyle) {
      var x1 = parsedStyle.x1,
          y1 = parsedStyle.y1,
          x2 = parsedStyle.x2,
          y2 = parsedStyle.y2,
          _parsedStyle$defX = parsedStyle.defX,
          x = _parsedStyle$defX === void 0 ? 0 : _parsedStyle$defX,
          _parsedStyle$defY = parsedStyle.defY,
          y = _parsedStyle$defY === void 0 ? 0 : _parsedStyle$defY,
          stroke = parsedStyle.stroke;
      $el.setAttribute('x1', "" + (x1.value - x));
      $el.setAttribute('y1', "" + (y1.value - y));
      $el.setAttribute('x2', "" + (x2.value - x)); // fix horizontal line stroke url bug in Chrome
      // @see https://stackoverflow.com/questions/14680240/did-chrome-break-svg-stroke-url

      if (y1.value === y2.value && stroke && !(stroke instanceof g.CSSRGB)) {
        $el.setAttribute('y2', "" + (y2.value - y + 0.00001));
      } else {
        $el.setAttribute('y2', "" + (y2.value - y));
      }
    };

    return LineRenderer;
  }();

  LineRenderer = __decorate([manaSyringe.singleton()], LineRenderer);

  var PolylineRenderer = /*#__PURE__*/function () {
    function PolylineRenderer() {
      this.dependencies = ['points'];
    }

    var _proto = PolylineRenderer.prototype;

    _proto.apply = function apply($el, parsedStyle) {
      var points = parsedStyle.points,
          _parsedStyle$defX = parsedStyle.defX,
          x = _parsedStyle$defX === void 0 ? 0 : _parsedStyle$defX,
          _parsedStyle$defY = parsedStyle.defY,
          y = _parsedStyle$defY === void 0 ? 0 : _parsedStyle$defY;

      if (points && points.points && points.points.length >= 2) {
        $el.setAttribute('points', points.points.map(function (point) {
          return point[0] - x + "," + (point[1] - y);
        }).join(' '));
      }
    };

    return PolylineRenderer;
  }();

  PolylineRenderer = __decorate([manaSyringe.singleton()], PolylineRenderer);

  function numberToLongString(x) {
    return x.toFixed(6).replace('.000000', '');
  }

  function convertHTML(str) {
    var regex = /[&|<|>|"|']/g;
    return str.replace(regex, function (match) {
      if (match === '&') {
        return '&amp;';
      } else if (match === '<') {
        return '&lt;';
      } else if (match === '>') {
        return '&gt;';
      } else if (match === '"') {
        return '&quot;';
      } else {
        return '&apos;';
      }
    });
  }

  var BASELINE_MAP = {
    top: 'before-edge',
    middle: 'central',
    bottom: 'after-edge',
    alphabetic: 'alphabetic',
    ideographic: 'ideographic',
    hanging: 'hanging'
  }; // for FireFox
  // @see https://github.com/plouc/nivo/issues/164

  var BASELINE_MAP_FOR_FIREFOX = {
    top: 'text-before-edge',
    middle: 'central',
    bottom: 'text-after-edge',
    alphabetic: 'alphabetic',
    ideographic: 'ideographic',
    hanging: 'hanging'
  };

  var TextRenderer = /*#__PURE__*/function () {
    function TextRenderer() {
      this.dependencies = ['text', 'font', 'fontSize', 'fontFamily', 'fontStyle', 'fontWeight', 'fontVariant', 'lineHeight', 'letterSpacing', 'wordWrap', 'wordWrapWidth', 'leading', 'textBaseline', 'textAlign', 'textTransform', 'whiteSpace', 'dx', 'dy'];
    }

    var _proto = TextRenderer.prototype;

    _proto.apply = function apply($el, parsedStyle) {
      var textBaseline = parsedStyle.textBaseline,
          lineWidth = parsedStyle.lineWidth,
          metrics = parsedStyle.metrics,
          dx = parsedStyle.dx,
          dy = parsedStyle.dy;
      var browser = detect();

      if (browser && browser.name === 'firefox') {
        // compatible with FireFox browser, ref: https://github.com/antvis/g/issues/119
        $el.setAttribute('dominant-baseline', BASELINE_MAP_FOR_FIREFOX[textBaseline.value] || 'alphabetic');
      } else {
        $el.setAttribute('dominant-baseline', BASELINE_MAP_FOR_FIREFOX[textBaseline.value]);
        $el.setAttribute('alignment-baseline', BASELINE_MAP[textBaseline.value]);
      }

      $el.setAttribute('paint-order', 'stroke');
      var lines = metrics.lines,
          lineHeight = metrics.lineHeight,
          height = metrics.height;
      var lineNum = lines.length;
      $el.setAttribute('style', "transform:translate(" + dx.toString() + ", " + dy.toString() + ");");

      if (lineNum === 1) {
        $el.innerHTML = convertHTML(lines[0]);
        $el.setAttribute('dx', "" + lineWidth.value / 2);
      } else {
        $el.innerHTML = lines.map(function (line, i) {
          var dx = lineWidth.value / 2;
          var dy = 0;

          if (i === 0) {
            // TODO: handle other textBaseline values
            if (textBaseline.value === 'middle') {
              dy = lineHeight / 2 - height / 2;
            } else if (textBaseline.value === 'top' || textBaseline.value === 'hanging') {
              dy = 0;
            } else if (textBaseline.value === 'bottom' || textBaseline.value === 'alphabetic' || textBaseline.value === 'ideographic') {
              dy = -lineHeight * (lineNum - 1);
            }
          } else {
            dy = lineHeight;
          }

          return "<tspan x=\"0\" dx=\"" + dx + "\" dy=\"" + dy + "\">" + convertHTML(line) + "</tspan>";
        }).join('');
      }
    };

    return TextRenderer;
  }();

  TextRenderer = __decorate([manaSyringe.singleton()], TextRenderer);

  var PathRenderer = /*#__PURE__*/function () {
    function PathRenderer() {
      this.dependencies = ['path'];
    }

    var _proto = PathRenderer.prototype;

    _proto.apply = function apply($el, parsedStyle) {
      var path = parsedStyle.path,
          _parsedStyle$defX = parsedStyle.defX,
          x = _parsedStyle$defX === void 0 ? 0 : _parsedStyle$defX,
          _parsedStyle$defY = parsedStyle.defY,
          y = _parsedStyle$defY === void 0 ? 0 : _parsedStyle$defY;
      $el.setAttribute('d', this.formatPath(path.absolutePath, x, y));
    };

    _proto.formatPath = function formatPath(value, x, y) {
      var newValue = value.map(function (params) {
        var command = params[0];

        switch (command) {
          case 'M':
            return "M " + (params[1] - x) + "," + (params[2] - y);

          case 'L':
            return "L " + (params[1] - x) + "," + (params[2] - y);

          case 'Q':
            return "Q " + (params[1] - x) + " " + (params[2] - y) + "," + (params[3] - x) + " " + (params[4] - y);

          case 'C':
            return "C " + (params[1] - x) + " " + (params[2] - y) + "," + (params[3] - x) + " " + (params[4] - y) + "," + (params[5] - x) + " " + (params[6] - y);

          case 'A':
            return "A " + params[1] + " " + params[2] + " " + params[3] + " " + params[4] + " " + params[5] + " " + (params[6] - x) + " " + (params[7] - y);

          case 'Z':
            return 'Z';
        }
      }).join(' ');

      if (~newValue.indexOf('NaN')) {
        return '';
      }

      return newValue;
    };

    return PathRenderer;
  }();

  PathRenderer = __decorate([manaSyringe.singleton()], PathRenderer);
  var ElementRendererFactory = manaSyringe.Syringe.defineToken('ElementRendererFactory');
  var ElementRenderer = manaSyringe.Syringe.defineToken('ElementRenderer');

  function _regeneratorRuntime$1() {
    /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */
    _regeneratorRuntime$1 = function _regeneratorRuntime() {
      return exports;
    };

    var exports = {},
        Op = Object.prototype,
        hasOwn = Op.hasOwnProperty,
        $Symbol = "function" == typeof Symbol ? Symbol : {},
        iteratorSymbol = $Symbol.iterator || "@@iterator",
        asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
        toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      return Object.defineProperty(obj, key, {
        value: value,
        enumerable: !0,
        configurable: !0,
        writable: !0
      }), obj[key];
    }

    try {
      define({}, "");
    } catch (err) {
      define = function define(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
          generator = Object.create(protoGenerator.prototype),
          context = new Context(tryLocsList || []);
      return generator._invoke = function (innerFn, self, context) {
        var state = "suspendedStart";
        return function (method, arg) {
          if ("executing" === state) throw new Error("Generator is already running");

          if ("completed" === state) {
            if ("throw" === method) throw arg;
            return doneResult();
          }

          for (context.method = method, context.arg = arg;;) {
            var delegate = context.delegate;

            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context);

              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue;
                return delegateResult;
              }
            }

            if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
              if ("suspendedStart" === state) throw state = "completed", context.arg;
              context.dispatchException(context.arg);
            } else "return" === context.method && context.abrupt("return", context.arg);
            state = "executing";
            var record = tryCatch(innerFn, self, context);

            if ("normal" === record.type) {
              if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
              return {
                value: record.arg,
                done: context.done
              };
            }

            "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
          }
        };
      }(innerFn, self, context), generator;
    }

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    exports.wrap = wrap;
    var ContinueSentinel = {};

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {}

    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });
    var getProto = Object.getPrototypeOf,
        NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if ("throw" !== record.type) {
          var result = record.arg,
              value = result.value;
          return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          }) : PromiseImpl.resolve(value).then(function (unwrapped) {
            result.value = unwrapped, resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }

        reject(record.arg);
      }

      var previousPromise;

      this._invoke = function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      };
    }

    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (undefined === method) {
        if (context.delegate = null, "throw" === context.method) {
          if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
          context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);
      if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
      var info = record.arg;
      return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
    }

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };
      1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal", delete record.arg, entry.completion = record;
    }

    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
    }

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) return iteratorMethod.call(iterable);
        if ("function" == typeof iterable.next) return iterable;

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            for (; ++i < iterable.length;) {
              if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            }

            return next.value = undefined, next.done = !0, next;
          };

          return next.next = next;
        }
      }

      return {
        next: doneResult
      };
    }

    function doneResult() {
      return {
        value: undefined,
        done: !0
      };
    }

    return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
      var ctor = "function" == typeof genFun && genFun.constructor;
      return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
    }, exports.mark = function (genFun) {
      return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
    }, exports.awrap = function (arg) {
      return {
        __await: arg
      };
    }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      void 0 === PromiseImpl && (PromiseImpl = Promise);
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
      return this;
    }), define(Gp, "toString", function () {
      return "[object Generator]";
    }), exports.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      return keys.reverse(), function next() {
        for (; keys.length;) {
          var key = keys.pop();
          if (key in object) return next.value = key, next.done = !1, next;
        }

        return next.done = !0, next;
      };
    }, exports.values = values, Context.prototype = {
      constructor: Context,
      reset: function reset(skipTempReset) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) {
          "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
        }
      },
      stop: function stop() {
        this.done = !0;
        var rootRecord = this.tryEntries[0].completion;
        if ("throw" === rootRecord.type) throw rootRecord.arg;
        return this.rval;
      },
      dispatchException: function dispatchException(exception) {
        if (this.done) throw exception;
        var context = this;

        function handle(loc, caught) {
          return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i],
              record = entry.completion;
          if ("root" === entry.tryLoc) return handle("end");

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc"),
                hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            } else {
              if (!hasFinally) throw new Error("try statement without catch or finally");
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            }
          }
        }
      },
      abrupt: function abrupt(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
        var record = finallyEntry ? finallyEntry.completion : {};
        return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
      },
      complete: function complete(record, afterLoc) {
        if ("throw" === record.type) throw record.arg;
        return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
      },
      finish: function finish(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
        }
      },
      catch: function _catch(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if ("throw" === record.type) {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        }

        throw new Error("illegal catch attempt");
      },
      delegateYield: function delegateYield(iterable, resultName, nextLoc) {
        return this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
      }
    }, exports;
  }

  function asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator$1(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }
  /**
   * Common utilities
   * @module glMatrix
   */
  // Configuration Constants


  var EPSILON = 0.000001;
  var ARRAY_TYPE = typeof Float32Array !== 'undefined' ? Float32Array : Array;
  if (!Math.hypot) Math.hypot = function () {
    var y = 0,
        i = arguments.length;

    while (i--) {
      y += arguments[i] * arguments[i];
    }

    return Math.sqrt(y);
  };
  /**
   * 3x3 Matrix
   * @module mat3
   */

  /**
   * Creates a new identity mat3
   *
   * @returns {mat3} a new 3x3 matrix
   */

  function create() {
    var out = new ARRAY_TYPE(9);

    if (ARRAY_TYPE != Float32Array) {
      out[1] = 0;
      out[2] = 0;
      out[3] = 0;
      out[5] = 0;
      out[6] = 0;
      out[7] = 0;
    }

    out[0] = 1;
    out[4] = 1;
    out[8] = 1;
    return out;
  }
  /**
   * Returns the translation vector component of a transformation
   *  matrix. If a matrix is built with fromRotationTranslation,
   *  the returned vector will be the same as the translation vector
   *  originally supplied.
   * @param  {vec3} out Vector to receive translation component
   * @param  {ReadonlyMat4} mat Matrix to be decomposed (input)
   * @return {vec3} out
   */


  function getTranslation(out, mat) {
    out[0] = mat[12];
    out[1] = mat[13];
    out[2] = mat[14];
    return out;
  }
  /**
   * Returns the scaling factor component of a transformation
   *  matrix. If a matrix is built with fromRotationTranslationScale
   *  with a normalized Quaternion paramter, the returned vector will be
   *  the same as the scaling vector
   *  originally supplied.
   * @param  {vec3} out Vector to receive scaling factor component
   * @param  {ReadonlyMat4} mat Matrix to be decomposed (input)
   * @return {vec3} out
   */


  function getScaling(out, mat) {
    var m11 = mat[0];
    var m12 = mat[1];
    var m13 = mat[2];
    var m21 = mat[4];
    var m22 = mat[5];
    var m23 = mat[6];
    var m31 = mat[8];
    var m32 = mat[9];
    var m33 = mat[10];
    out[0] = Math.hypot(m11, m12, m13);
    out[1] = Math.hypot(m21, m22, m23);
    out[2] = Math.hypot(m31, m32, m33);
    return out;
  }
  /**
   * Returns a quaternion representing the rotational component
   *  of a transformation matrix. If a matrix is built with
   *  fromRotationTranslation, the returned quaternion will be the
   *  same as the quaternion originally supplied.
   * @param {quat} out Quaternion to receive the rotation component
   * @param {ReadonlyMat4} mat Matrix to be decomposed (input)
   * @return {quat} out
   */


  function getRotation(out, mat) {
    var scaling = new ARRAY_TYPE(3);
    getScaling(scaling, mat);
    var is1 = 1 / scaling[0];
    var is2 = 1 / scaling[1];
    var is3 = 1 / scaling[2];
    var sm11 = mat[0] * is1;
    var sm12 = mat[1] * is2;
    var sm13 = mat[2] * is3;
    var sm21 = mat[4] * is1;
    var sm22 = mat[5] * is2;
    var sm23 = mat[6] * is3;
    var sm31 = mat[8] * is1;
    var sm32 = mat[9] * is2;
    var sm33 = mat[10] * is3;
    var trace = sm11 + sm22 + sm33;
    var S = 0;

    if (trace > 0) {
      S = Math.sqrt(trace + 1.0) * 2;
      out[3] = 0.25 * S;
      out[0] = (sm23 - sm32) / S;
      out[1] = (sm31 - sm13) / S;
      out[2] = (sm12 - sm21) / S;
    } else if (sm11 > sm22 && sm11 > sm33) {
      S = Math.sqrt(1.0 + sm11 - sm22 - sm33) * 2;
      out[3] = (sm23 - sm32) / S;
      out[0] = 0.25 * S;
      out[1] = (sm12 + sm21) / S;
      out[2] = (sm31 + sm13) / S;
    } else if (sm22 > sm33) {
      S = Math.sqrt(1.0 + sm22 - sm11 - sm33) * 2;
      out[3] = (sm31 - sm13) / S;
      out[0] = (sm12 + sm21) / S;
      out[1] = 0.25 * S;
      out[2] = (sm23 + sm32) / S;
    } else {
      S = Math.sqrt(1.0 + sm33 - sm11 - sm22) * 2;
      out[3] = (sm12 - sm21) / S;
      out[0] = (sm31 + sm13) / S;
      out[1] = (sm23 + sm32) / S;
      out[2] = 0.25 * S;
    }

    return out;
  }
  /**
   * 3 Dimensional Vector
   * @module vec3
   */

  /**
   * Creates a new, empty vec3
   *
   * @returns {vec3} a new 3D vector
   */


  function create$1() {
    var out = new ARRAY_TYPE(3);

    if (ARRAY_TYPE != Float32Array) {
      out[0] = 0;
      out[1] = 0;
      out[2] = 0;
    }

    return out;
  }
  /**
   * Calculates the length of a vec3
   *
   * @param {ReadonlyVec3} a vector to calculate length of
   * @returns {Number} length of a
   */


  function length(a) {
    var x = a[0];
    var y = a[1];
    var z = a[2];
    return Math.hypot(x, y, z);
  }
  /**
   * Creates a new vec3 initialized with the given values
   *
   * @param {Number} x X component
   * @param {Number} y Y component
   * @param {Number} z Z component
   * @returns {vec3} a new 3D vector
   */


  function fromValues(x, y, z) {
    var out = new ARRAY_TYPE(3);
    out[0] = x;
    out[1] = y;
    out[2] = z;
    return out;
  }
  /**
   * Normalize a vec3
   *
   * @param {vec3} out the receiving vector
   * @param {ReadonlyVec3} a vector to normalize
   * @returns {vec3} out
   */


  function normalize(out, a) {
    var x = a[0];
    var y = a[1];
    var z = a[2];
    var len = x * x + y * y + z * z;

    if (len > 0) {
      //TODO: evaluate use of glm_invsqrt here?
      len = 1 / Math.sqrt(len);
    }

    out[0] = a[0] * len;
    out[1] = a[1] * len;
    out[2] = a[2] * len;
    return out;
  }
  /**
   * Calculates the dot product of two vec3's
   *
   * @param {ReadonlyVec3} a the first operand
   * @param {ReadonlyVec3} b the second operand
   * @returns {Number} dot product of a and b
   */


  function dot(a, b) {
    return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
  }
  /**
   * Computes the cross product of two vec3's
   *
   * @param {vec3} out the receiving vector
   * @param {ReadonlyVec3} a the first operand
   * @param {ReadonlyVec3} b the second operand
   * @returns {vec3} out
   */


  function cross(out, a, b) {
    var ax = a[0],
        ay = a[1],
        az = a[2];
    var bx = b[0],
        by = b[1],
        bz = b[2];
    out[0] = ay * bz - az * by;
    out[1] = az * bx - ax * bz;
    out[2] = ax * by - ay * bx;
    return out;
  }
  /**
   * Alias for {@link vec3.length}
   * @function
   */


  var len = length;
  /**
   * Perform some operation over an array of vec3s.
   *
   * @param {Array} a the array of vectors to iterate over
   * @param {Number} stride Number of elements between the start of each vec3. If 0 assumes tightly packed
   * @param {Number} offset Number of elements to skip at the beginning of the array
   * @param {Number} count Number of vec3s to iterate over. If 0 iterates over entire array
   * @param {Function} fn Function to call for each vector in the array
   * @param {Object} [arg] additional argument to pass to fn
   * @returns {Array} a
   * @function
   */

  var forEach = function () {
    var vec = create$1();
    return function (a, stride, offset, count, fn, arg) {
      var i, l;

      if (!stride) {
        stride = 3;
      }

      if (!offset) {
        offset = 0;
      }

      if (count) {
        l = Math.min(count * stride + offset, a.length);
      } else {
        l = a.length;
      }

      for (i = offset; i < l; i += stride) {
        vec[0] = a[i];
        vec[1] = a[i + 1];
        vec[2] = a[i + 2];
        fn(vec, vec, arg);
        a[i] = vec[0];
        a[i + 1] = vec[1];
        a[i + 2] = vec[2];
      }

      return a;
    };
  }();
  /**
   * 4 Dimensional Vector
   * @module vec4
   */

  /**
   * Creates a new, empty vec4
   *
   * @returns {vec4} a new 4D vector
   */


  function create$2() {
    var out = new ARRAY_TYPE(4);

    if (ARRAY_TYPE != Float32Array) {
      out[0] = 0;
      out[1] = 0;
      out[2] = 0;
      out[3] = 0;
    }

    return out;
  }
  /**
   * Normalize a vec4
   *
   * @param {vec4} out the receiving vector
   * @param {ReadonlyVec4} a vector to normalize
   * @returns {vec4} out
   */


  function normalize$1(out, a) {
    var x = a[0];
    var y = a[1];
    var z = a[2];
    var w = a[3];
    var len = x * x + y * y + z * z + w * w;

    if (len > 0) {
      len = 1 / Math.sqrt(len);
    }

    out[0] = x * len;
    out[1] = y * len;
    out[2] = z * len;
    out[3] = w * len;
    return out;
  }
  /**
   * Perform some operation over an array of vec4s.
   *
   * @param {Array} a the array of vectors to iterate over
   * @param {Number} stride Number of elements between the start of each vec4. If 0 assumes tightly packed
   * @param {Number} offset Number of elements to skip at the beginning of the array
   * @param {Number} count Number of vec4s to iterate over. If 0 iterates over entire array
   * @param {Function} fn Function to call for each vector in the array
   * @param {Object} [arg] additional argument to pass to fn
   * @returns {Array} a
   * @function
   */


  var forEach$1 = function () {
    var vec = create$2();
    return function (a, stride, offset, count, fn, arg) {
      var i, l;

      if (!stride) {
        stride = 4;
      }

      if (!offset) {
        offset = 0;
      }

      if (count) {
        l = Math.min(count * stride + offset, a.length);
      } else {
        l = a.length;
      }

      for (i = offset; i < l; i += stride) {
        vec[0] = a[i];
        vec[1] = a[i + 1];
        vec[2] = a[i + 2];
        vec[3] = a[i + 3];
        fn(vec, vec, arg);
        a[i] = vec[0];
        a[i + 1] = vec[1];
        a[i + 2] = vec[2];
        a[i + 3] = vec[3];
      }

      return a;
    };
  }();
  /**
   * Quaternion
   * @module quat
   */

  /**
   * Creates a new identity quat
   *
   * @returns {quat} a new quaternion
   */


  function create$3() {
    var out = new ARRAY_TYPE(4);

    if (ARRAY_TYPE != Float32Array) {
      out[0] = 0;
      out[1] = 0;
      out[2] = 0;
    }

    out[3] = 1;
    return out;
  }
  /**
   * Sets a quat from the given angle and rotation axis,
   * then returns it.
   *
   * @param {quat} out the receiving quaternion
   * @param {ReadonlyVec3} axis the axis around which to rotate
   * @param {Number} rad the angle in radians
   * @returns {quat} out
   **/


  function setAxisAngle(out, axis, rad) {
    rad = rad * 0.5;
    var s = Math.sin(rad);
    out[0] = s * axis[0];
    out[1] = s * axis[1];
    out[2] = s * axis[2];
    out[3] = Math.cos(rad);
    return out;
  }
  /**
   * Performs a spherical linear interpolation between two quat
   *
   * @param {quat} out the receiving quaternion
   * @param {ReadonlyQuat} a the first operand
   * @param {ReadonlyQuat} b the second operand
   * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
   * @returns {quat} out
   */


  function slerp(out, a, b, t) {
    // benchmarks:
    //    http://jsperf.com/quaternion-slerp-implementations
    var ax = a[0],
        ay = a[1],
        az = a[2],
        aw = a[3];
    var bx = b[0],
        by = b[1],
        bz = b[2],
        bw = b[3];
    var omega, cosom, sinom, scale0, scale1; // calc cosine

    cosom = ax * bx + ay * by + az * bz + aw * bw; // adjust signs (if necessary)

    if (cosom < 0.0) {
      cosom = -cosom;
      bx = -bx;
      by = -by;
      bz = -bz;
      bw = -bw;
    } // calculate coefficients


    if (1.0 - cosom > EPSILON) {
      // standard case (slerp)
      omega = Math.acos(cosom);
      sinom = Math.sin(omega);
      scale0 = Math.sin((1.0 - t) * omega) / sinom;
      scale1 = Math.sin(t * omega) / sinom;
    } else {
      // "from" and "to" quaternions are very close
      //  ... so we can do a linear interpolation
      scale0 = 1.0 - t;
      scale1 = t;
    } // calculate final values


    out[0] = scale0 * ax + scale1 * bx;
    out[1] = scale0 * ay + scale1 * by;
    out[2] = scale0 * az + scale1 * bz;
    out[3] = scale0 * aw + scale1 * bw;
    return out;
  }
  /**
   * Creates a quaternion from the given 3x3 rotation matrix.
   *
   * NOTE: The resultant quaternion is not normalized, so you should be sure
   * to renormalize the quaternion yourself where necessary.
   *
   * @param {quat} out the receiving quaternion
   * @param {ReadonlyMat3} m rotation matrix
   * @returns {quat} out
   * @function
   */


  function fromMat3(out, m) {
    // Algorithm in Ken Shoemake's article in 1987 SIGGRAPH course notes
    // article "Quaternion Calculus and Fast Animation".
    var fTrace = m[0] + m[4] + m[8];
    var fRoot;

    if (fTrace > 0.0) {
      // |w| > 1/2, may as well choose w > 1/2
      fRoot = Math.sqrt(fTrace + 1.0); // 2w

      out[3] = 0.5 * fRoot;
      fRoot = 0.5 / fRoot; // 1/(4w)

      out[0] = (m[5] - m[7]) * fRoot;
      out[1] = (m[6] - m[2]) * fRoot;
      out[2] = (m[1] - m[3]) * fRoot;
    } else {
      // |w| <= 1/2
      var i = 0;
      if (m[4] > m[0]) i = 1;
      if (m[8] > m[i * 3 + i]) i = 2;
      var j = (i + 1) % 3;
      var k = (i + 2) % 3;
      fRoot = Math.sqrt(m[i * 3 + i] - m[j * 3 + j] - m[k * 3 + k] + 1.0);
      out[i] = 0.5 * fRoot;
      fRoot = 0.5 / fRoot;
      out[3] = (m[j * 3 + k] - m[k * 3 + j]) * fRoot;
      out[j] = (m[j * 3 + i] + m[i * 3 + j]) * fRoot;
      out[k] = (m[k * 3 + i] + m[i * 3 + k]) * fRoot;
    }

    return out;
  }
  /**
   * Normalize a quat
   *
   * @param {quat} out the receiving quaternion
   * @param {ReadonlyQuat} a quaternion to normalize
   * @returns {quat} out
   * @function
   */


  var normalize$2 = normalize$1;
  /**
   * Sets a quaternion to represent the shortest rotation from one
   * vector to another.
   *
   * Both vectors are assumed to be unit length.
   *
   * @param {quat} out the receiving quaternion.
   * @param {ReadonlyVec3} a the initial vector
   * @param {ReadonlyVec3} b the destination vector
   * @returns {quat} out
   */

  var rotationTo = function () {
    var tmpvec3 = create$1();
    var xUnitVec3 = fromValues(1, 0, 0);
    var yUnitVec3 = fromValues(0, 1, 0);
    return function (out, a, b) {
      var dot$1 = dot(a, b);

      if (dot$1 < -0.999999) {
        cross(tmpvec3, xUnitVec3, a);
        if (len(tmpvec3) < 0.000001) cross(tmpvec3, yUnitVec3, a);
        normalize(tmpvec3, tmpvec3);
        setAxisAngle(out, tmpvec3, Math.PI);
        return out;
      } else if (dot$1 > 0.999999) {
        out[0] = 0;
        out[1] = 0;
        out[2] = 0;
        out[3] = 1;
        return out;
      } else {
        cross(tmpvec3, a, b);
        out[0] = tmpvec3[0];
        out[1] = tmpvec3[1];
        out[2] = tmpvec3[2];
        out[3] = 1 + dot$1;
        return normalize$2(out, out);
      }
    };
  }();
  /**
   * Performs a spherical linear interpolation with two control points
   *
   * @param {quat} out the receiving quaternion
   * @param {ReadonlyQuat} a the first operand
   * @param {ReadonlyQuat} b the second operand
   * @param {ReadonlyQuat} c the third operand
   * @param {ReadonlyQuat} d the fourth operand
   * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
   * @returns {quat} out
   */


  var sqlerp = function () {
    var temp1 = create$3();
    var temp2 = create$3();
    return function (out, a, b, c, d, t) {
      slerp(temp1, a, d, t);
      slerp(temp2, b, c, t);
      slerp(out, temp1, temp2, 2 * t * (1 - t));
      return out;
    };
  }();
  /**
   * Sets the specified quaternion with values corresponding to the given
   * axes. Each axis is a vec3 and is expected to be unit length and
   * perpendicular to all other specified axes.
   *
   * @param {ReadonlyVec3} view  the vector representing the viewing direction
   * @param {ReadonlyVec3} right the vector representing the local "right" direction
   * @param {ReadonlyVec3} up    the vector representing the local "up" direction
   * @returns {quat} out
   */


  var setAxes = function () {
    var matr = create();
    return function (out, view, right, up) {
      matr[0] = right[0];
      matr[3] = right[1];
      matr[6] = right[2];
      matr[1] = up[0];
      matr[4] = up[1];
      matr[7] = up[2];
      matr[2] = -view[0];
      matr[5] = -view[1];
      matr[8] = -view[2];
      return normalize$2(out, fromMat3(out, matr));
    };
  }();

  function createSVGElement(type) {
    return document.createElementNS('http://www.w3.org/2000/svg', type);
  }

  var FILTER_PREFIX = 'g-filter-';
  /**
   * use SVG filters, eg. blur, brightness, contrast...
   * @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Element/filter
   */

  function createOrUpdateFilter($def, object, $el, filters) {
    // eg. filter="url(#f1) url(#f2)"
    var filterName = FILTER_PREFIX + object.entity;
    var $existedFilters = $def.querySelectorAll("[name=" + filterName + "]");

    if ($existedFilters.length) {
      $existedFilters.forEach(function ($filter) {
        $def.removeChild($filter);
      });
    }

    if (filters.length === 0) {
      // 'none'
      $el === null || $el === void 0 ? void 0 : $el.removeAttribute('filter');
    } else {
      var filterIds = filters.map(function (_ref, i) {
        var name = _ref.name,
            params = _ref.params;
        var $filter = createSVGElement('filter');

        if (name === 'blur') {
          createBlur($filter, params);
        } else if (name === 'brightness') {
          createBrightness($filter, params);
        } else if (name === 'drop-shadow') {
          createDropShadow($filter, params);
        } else if (name === 'contrast') {
          createContrast($filter, params);
        } else if (name === 'grayscale') {
          createGrayscale($filter, params);
        } else if (name === 'sepia') {
          createSepia($filter, params);
        } else if (name === 'saturate') {
          createSaturate($filter, params);
        } else if (name === 'hue-rotate') {
          createHueRotate($filter, params);
        } else if (name === 'invert') {
          createInvert($filter, params);
        }

        $filter.id = filterName + "-" + i;
        $filter.setAttribute('name', filterName);
        $def.appendChild($filter);
        return $filter.id;
      });
      $el === null || $el === void 0 ? void 0 : $el.setAttribute('filter', filterIds.map(function (filterId) {
        return "url(#" + filterId + ")";
      }).join(' '));
    }
  }

  function convertToAbsoluteValue(param) {
    return param.unit === g.UnitType.kPercentage ? param.value / 100 : param.value;
  }
  /**
   * @see https://drafts.fxtf.org/filter-effects/#blurEquivalent
   */


  function createBlur($filter, params) {
    var $feGaussianBlur = createSVGElement('feGaussianBlur');
    $feGaussianBlur.setAttribute('in', 'SourceGraphic');
    $feGaussianBlur.setAttribute('stdDeviation', "" + params[0].value);
    $filter.appendChild($feGaussianBlur);
  }

  function createFeComponentTransfer($filter, _ref2) {
    var type = _ref2.type,
        slope = _ref2.slope,
        intercept = _ref2.intercept,
        tableValues = _ref2.tableValues;
    var $feComponentTransfer = createSVGElement('feComponentTransfer');
    [createSVGElement('feFuncR'), createSVGElement('feFuncG'), createSVGElement('feFuncB')].forEach(function ($feFunc) {
      $feFunc.setAttribute('type', type);

      if (type === 'table') {
        $feFunc.setAttribute('tableValues', "" + tableValues);
      } else {
        $feFunc.setAttribute('slope', "" + slope);
        $feFunc.setAttribute('intercept', "" + intercept);
      }

      $feComponentTransfer.appendChild($feFunc);
    });
    $filter.appendChild($feComponentTransfer);
  }

  function createContrast($filter, params) {
    var slope = convertToAbsoluteValue(params[0]);
    createFeComponentTransfer($filter, {
      type: 'linear',
      slope: slope,
      intercept: -(0.5 * slope) + 0.5
    });
  }

  function createInvert($filter, params) {
    var amount = convertToAbsoluteValue(params[0]);
    createFeComponentTransfer($filter, {
      type: 'table',
      tableValues: amount + " " + (1 - amount)
    });
  }

  function createBrightness($filter, params) {
    var slope = convertToAbsoluteValue(params[0]);
    createFeComponentTransfer($filter, {
      type: 'linear',
      slope: slope,
      intercept: 0
    });
  }

  function createSaturate($filter, params) {
    var amount = convertToAbsoluteValue(params[0]);
    var $feColorMatrix = createSVGElement('feColorMatrix');
    $feColorMatrix.setAttribute('type', 'saturate');
    $feColorMatrix.setAttribute('values', "" + amount);
    $filter.appendChild($feColorMatrix);
  }

  function createHueRotate($filter, params) {
    var $feColorMatrix = createSVGElement('feColorMatrix');
    $feColorMatrix.setAttribute('type', 'hueRotate');
    $feColorMatrix.setAttribute('values', "" + params[0].to(g.UnitType.kDegrees).value);
    $filter.appendChild($feColorMatrix);
  }

  function createDropShadow($filter, params) {
    var shadowOffsetX = params[0].value;
    var shadowOffsetY = params[1].value;
    var shadowBlur = params[2].value; // @ts-ignore

    var shadowColor = params[3].formatted;
    var $feGaussianBlur = createSVGElement('feGaussianBlur');
    $feGaussianBlur.setAttribute('in', 'SourceAlpha');
    $feGaussianBlur.setAttribute('stdDeviation', "" + shadowBlur);
    $filter.appendChild($feGaussianBlur);
    var $feOffset = createSVGElement('feOffset');
    $feOffset.setAttribute('dx', "" + shadowOffsetX);
    $feOffset.setAttribute('dy', "" + shadowOffsetY);
    $feOffset.setAttribute('result', 'offsetblur');
    $filter.appendChild($feOffset);
    var $feFlood = createSVGElement('feFlood');
    $feFlood.setAttribute('flood-color', shadowColor);
    $filter.appendChild($feFlood);
    var $feComposite = createSVGElement('feComposite');
    $feComposite.setAttribute('in2', 'offsetblur');
    $feComposite.setAttribute('operator', 'in');
    $filter.appendChild($feComposite);
    var $feMerge = createSVGElement('feMerge');
    $filter.appendChild($feMerge);
    var $feMergeNode1 = createSVGElement('feMergeNode');
    var $feMergeNode2 = createSVGElement('feMergeNode');
    $feMergeNode2.setAttribute('in', 'SourceGraphic');
    $feMerge.appendChild($feMergeNode1);
    $feMerge.appendChild($feMergeNode2);
  }

  function createFeColorMatrix($filter, matrix) {
    var $feColorMatrix = createSVGElement('feColorMatrix');
    $feColorMatrix.setAttribute('type', 'matrix');
    $feColorMatrix.setAttribute('values', matrix.join(' '));
    $filter.appendChild($feColorMatrix);
  }
  /**
   * @see https://drafts.fxtf.org/filter-effects/#grayscaleEquivalent
   */


  function createGrayscale($filter, params) {
    var amount = convertToAbsoluteValue(params[0]);
    createFeColorMatrix($filter, [0.2126 + 0.7874 * (1 - amount), 0.7152 - 0.7152 * (1 - amount), 0.0722 - 0.0722 * (1 - amount), 0, 0, 0.2126 - 0.2126 * (1 - amount), 0.7152 + 0.2848 * (1 - amount), 0.0722 - 0.0722 * (1 - amount), 0, 0, 0.2126 - 0.2126 * (1 - amount), 0.7152 - 0.7152 * (1 - amount), 0.0722 + 0.9278 * (1 - amount), 0, 0, 0, 0, 0, 1, 0]);
  }
  /**
   * @see https://drafts.fxtf.org/filter-effects/#sepiaEquivalent
   */


  function createSepia($filter, params) {
    var amount = convertToAbsoluteValue(params[0]);
    createFeColorMatrix($filter, [0.393 + 0.607 * (1 - amount), 0.769 - 0.769 * (1 - amount), 0.189 - 0.189 * (1 - amount), 0, 0, 0.349 - 0.349 * (1 - amount), 0.686 + 0.314 * (1 - amount), 0.168 - 0.168 * (1 - amount), 0, 0, 0.272 - 0.272 * (1 - amount), 0.534 - 0.534 * (1 - amount), 0.131 + 0.869 * (1 - amount), 0, 0, 0, 0, 0, 1, 0]);
  }

  var cacheKey2IDMap = {};
  var counter = 0;

  function createOrUpdateGradientAndPattern($def, object, $el, parsedColor, name) {
    // eg. clipPath don't have fill/stroke
    if (!parsedColor) {
      return;
    }

    var gradientId = generateCacheKey(parsedColor);
    var existed = $def.querySelector("#" + gradientId);

    if (parsedColor instanceof g.CSSRGB) {
      // keep using currentColor @see https://github.com/d3/d3-axis/issues/49
      if (object.style[name] === 'currentColor') {
        $el === null || $el === void 0 ? void 0 : $el.setAttribute(name, 'currentColor');
      } else {
        // constant value, eg. '#fff'
        $el === null || $el === void 0 ? void 0 : $el.setAttribute(name, parsedColor.isNone ? 'none' : parsedColor.toString());
      }
    } else {
      if (parsedColor.type === g.GradientPatternType.Pattern) {
        if (!existed) {
          createPattern($def, parsedColor, gradientId);
        }

        $el === null || $el === void 0 ? void 0 : $el.setAttribute(name, "url(#" + gradientId + ")");
      } else {
        if (!existed) {
          createGradient($def, parsedColor, gradientId);
        }

        $el === null || $el === void 0 ? void 0 : $el.setAttribute(name, "url(#" + gradientId + ")");
      }
    }
  }

  function generateCacheKey(params) {
    var cacheKey = '';

    if (params instanceof g.CSSGradientValue) {
      var type = params.type;

      if (type === g.GradientPatternType.Pattern) {
        var src = params.value.src;
        cacheKey = src;
      } else if (type === g.GradientPatternType.LinearGradient || type === g.GradientPatternType.RadialGradient) {
        // @ts-ignore
        var _params$value = params.value,
            x0 = _params$value.x0,
            y0 = _params$value.y0,
            x1 = _params$value.x1,
            y1 = _params$value.y1,
            r1 = _params$value.r1,
            steps = _params$value.steps;
        cacheKey = "" + type + x0 + y0 + x1 + y1 + (r1 || 0) + steps.map(function (step) {
          return step.join('');
        }).join('');
      }

      if (cacheKey) {
        if (!cacheKey2IDMap[cacheKey]) {
          cacheKey2IDMap[cacheKey] = "_pattern_" + type + "_" + counter++;
        }
      }
    }

    return cacheKey2IDMap[cacheKey];
  }

  function createPattern($def, parsedColor, patternId) {
    var src = parsedColor.value.src; // @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Element/pattern

    var $pattern = createSVGElement('pattern');
    $pattern.setAttribute('patternUnits', 'userSpaceOnUse');
    var $image = createSVGElement('image');
    $pattern.appendChild($image);
    $pattern.id = patternId;
    $def.appendChild($pattern);
    $image.setAttribute('href', src);
    var img = new window.Image();

    if (!src.match(/^data:/i)) {
      img.crossOrigin = 'Anonymous';
    }

    img.src = src;

    function onload() {
      $pattern.setAttribute('width', "" + img.width);
      $pattern.setAttribute('height', "" + img.height);
    }

    if (img.complete) {
      onload();
    } else {
      img.onload = onload; // Fix onload() bug in IE9

      img.src = img.src;
    }
  }

  function createGradient($def, parsedColor, gradientId) {
    // <linearGradient> <radialGradient>
    // @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Element/linearGradient
    // @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Element/radialGradient
    var $gradient = createSVGElement(parsedColor.type === g.GradientPatternType.LinearGradient ? 'linearGradient' : 'radialGradient');

    if (parsedColor.type === g.GradientPatternType.LinearGradient) {
      var _parsedColor$value = parsedColor.value,
          x0 = _parsedColor$value.x0,
          y0 = _parsedColor$value.y0,
          x1 = _parsedColor$value.x1,
          y1 = _parsedColor$value.y1;
      $gradient.setAttribute('x1', "" + x0);
      $gradient.setAttribute('y1', "" + y0);
      $gradient.setAttribute('x2', "" + x1);
      $gradient.setAttribute('y2', "" + y1);
    } else {
      var _parsedColor$value2 = parsedColor.value,
          _x = _parsedColor$value2.x0,
          _y = _parsedColor$value2.y0,
          r1 = _parsedColor$value2.r1;
      $gradient.setAttribute('cx', "" + _x);
      $gradient.setAttribute('cy', "" + _y);
      $gradient.setAttribute('r', "" + r1 / 2);
    } // add stops


    var innerHTML = '';
    parsedColor.value.steps.forEach(function (_ref) {
      var offset = _ref[0],
          color = _ref[1];
      innerHTML += "<stop offset=\"" + offset + "\" stop-color=\"" + color + "\"></stop>";
    });
    $gradient.innerHTML = innerHTML;
    $gradient.id = gradientId;
    $def.appendChild($gradient);
  }

  var FILTER_DROPSHADOW_PREFIX = 'filter-dropshadow-';
  /**
   * use SVG filters
   * @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Element/filter
   */

  function createOrUpdateShadow($def, object, $el, name) {
    var shadowId = FILTER_DROPSHADOW_PREFIX + object.entity;
    var $existedFilter = $def.querySelector("#" + shadowId);

    if (!$existedFilter) {
      $existedFilter = createSVGElement('filter');

      var _$feDropShadow = createSVGElement('feDropShadow');

      _$feDropShadow.setAttribute('dx', '0');

      _$feDropShadow.setAttribute('dy', '0');

      $existedFilter.appendChild(_$feDropShadow);
      $existedFilter.id = shadowId;
      $def.appendChild($existedFilter);
    }

    var $feDropShadow = $existedFilter.children[0];

    if (name === 'shadowColor') {
      var parsedColor = object.parsedStyle[name];
      $feDropShadow.setAttribute('flood-color', parsedColor.toString());
    } else if (name === 'shadowBlur') {
      var shadowBlur = object.parsedStyle[name]; // half the blur radius
      // @see https://drafts.csswg.org/css-backgrounds/#shadow-blur
      // @see https://css-tricks.com/breaking-css-box-shadow-vs-drop-shadow/

      $feDropShadow.setAttribute('stdDeviation', "" + (shadowBlur && shadowBlur.value || 0) / 2);
    } else if (name === 'shadowOffsetX') {
      var shadowOffsetX = object.parsedStyle[name];
      $feDropShadow.setAttribute('dx', "" + (shadowOffsetX && shadowOffsetX.value || 0) / 2);
    } else if (name === 'shadowOffsetY') {
      var shadowOffsetY = object.parsedStyle[name];
      $feDropShadow.setAttribute('dy', "" + (shadowOffsetY && shadowOffsetY.value || 0) / 2);
    } // use filter <feDropShadow>
    // @see https://developer.mozilla.org/en-US/docs/Web/SVG/Element/feDropShadow


    $el === null || $el === void 0 ? void 0 : $el.setAttribute('filter', "url(#" + shadowId + ")");
  }

  var _SHAPE2TAGS, _class$1;

  var SVGRendererPlugin_1;
  var SHAPE2TAGS = (_SHAPE2TAGS = {}, _SHAPE2TAGS[g.Shape.RECT] = 'path', _SHAPE2TAGS[g.Shape.CIRCLE] = 'circle', _SHAPE2TAGS[g.Shape.ELLIPSE] = 'ellipse', _SHAPE2TAGS[g.Shape.IMAGE] = 'image', _SHAPE2TAGS[g.Shape.GROUP] = 'g', _SHAPE2TAGS[g.Shape.LINE] = 'line', _SHAPE2TAGS[g.Shape.POLYLINE] = 'polyline', _SHAPE2TAGS[g.Shape.POLYGON] = 'polygon', _SHAPE2TAGS[g.Shape.TEXT] = 'text', _SHAPE2TAGS[g.Shape.PATH] = 'path', _SHAPE2TAGS[g.Shape.HTML] = 'foreignObject', _SHAPE2TAGS);
  var SVG_ATTR_MAP = {
    opacity: 'opacity',
    fillStyle: 'fill',
    fill: 'fill',
    fillOpacity: 'fill-opacity',
    strokeStyle: 'stroke',
    strokeOpacity: 'stroke-opacity',
    stroke: 'stroke',
    clipPath: 'clip-path',
    r: 'r',
    rx: 'rx',
    ry: 'ry',
    width: 'width',
    height: 'height',
    lineCap: 'stroke-linecap',
    lineJoin: 'stroke-linejoin',
    lineWidth: 'stroke-width',
    lineDash: 'stroke-dasharray',
    lineDashOffset: 'stroke-dashoffset',
    miterLimit: 'stroke-miterlimit',
    font: 'font',
    fontSize: 'font-size',
    fontStyle: 'font-style',
    fontVariant: 'font-variant',
    fontWeight: 'font-weight',
    fontFamily: 'font-family',
    letterSpacing: 'letter-spacing',
    startArrow: 'marker-start',
    endArrow: 'marker-end',
    class: 'class',
    id: 'id',
    style: 'style',
    preserveAspectRatio: 'preserveAspectRatio',
    visibility: 'visibility',
    anchor: 'anchor',
    shadowColor: 'flood-color',
    shadowBlur: 'stdDeviation',
    shadowOffsetX: 'dx',
    shadowOffsetY: 'dy',
    filter: 'filter',
    innerHTML: 'innerHTML',
    textAlign: 'text-anchor'
  };
  var FORMAT_VALUE_MAP = {
    textAlign: {
      inherit: 'inherit',
      left: 'left',
      start: 'left',
      center: 'middle',
      right: 'end',
      end: 'end'
    }
  };
  var DEFAULT_VALUE_MAP = {
    textAlign: 'inherit',
    // textBaseline: 'alphabetic',
    // @see https://www.w3.org/TR/SVG/painting.html#LineCaps
    lineCap: 'butt',
    // @see https://www.w3.org/TR/SVG/painting.html#LineJoin
    lineJoin: 'miter',
    // @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Attribute/stroke-width
    lineWidth: '1px',
    opacity: '1',
    fillOpacity: '1',
    strokeOpacity: '1',
    strokeWidth: '0',
    strokeMiterLimit: '4',
    letterSpacing: '0',
    fontSize: 'inherit',
    fontFamily: 'inherit'
  };
  /**
   * G_SVG_PREFIX + nodeName + entity
   *
   * eg. g_svg_circle_345
   */

  var G_SVG_PREFIX = 'g_svg';
  var CLIP_PATH_PREFIX = 'clip-path-';
  var SVGRendererPlugin = SVGRendererPlugin_1 = (_class$1 = /*#__PURE__*/function () {
    function SVGRendererPlugin() {
      this.canvasConfig = void 0;
      this.camera = void 0;
      this.contextService = void 0;
      this.renderingContext = void 0;
      this.elementRendererFactory = void 0;
      this.$def = void 0;
      this.$camera = void 0;
      this.renderQueue = [];
    }

    var _proto = SVGRendererPlugin.prototype;

    _proto.apply = function apply(renderingService) {
      var _this = this;

      var handleMounted = function handleMounted(e) {
        var object = e.target; // create SVG DOM Node

        _this.createSVGDom(object, _this.$camera);
      };

      var handleUnmounted = function handleUnmounted(e) {
        var object = e.target;

        _this.removeSVGDom(object);
      };

      var handleAttributeChanged = function handleAttributeChanged(e) {
        var object = e.target; // @see https://github.com/antvis/g/issues/994
        // @ts-ignore

        if (!object.elementSVG) {
          return;
        }

        var attrName = e.attrName;

        if (attrName === 'zIndex') {
          var _object$parentNode, _object$parentNode$el;

          var parent = object.parentNode; // @ts-ignore

          var $groupEl = (_object$parentNode = object.parentNode) === null || _object$parentNode === void 0 ? void 0 : (_object$parentNode$el = _object$parentNode.elementSVG) === null || _object$parentNode$el === void 0 ? void 0 : _object$parentNode$el.$groupEl;
          var children = ((parent === null || parent === void 0 ? void 0 : parent.children) || []).slice();

          if ($groupEl) {
            _this.reorderChildren($groupEl, children);
          }
        } else if (attrName === 'increasedLineWidthForHitTesting') {
          // @ts-ignore
          var svgElement = object.elementSVG;

          _this.createOrUpdateHitArea(object, svgElement.$el, svgElement.$groupEl);
        }

        _this.updateAttribute(object, [attrName]);
      };

      renderingService.hooks.init.tapPromise(SVGRendererPlugin_1.tag, /*#__PURE__*/_asyncToGenerator$1( /*#__PURE__*/_regeneratorRuntime$1().mark(function _callee() {
        var $svg, background;
        return _regeneratorRuntime$1().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this.$def = createSVGElement('defs');
                $svg = _this.contextService.getContext();
                background = _this.canvasConfig.background;

                if (background) {
                  $svg.style.background = background;
                }

                $svg.appendChild(_this.$def); // @see https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/color-interpolation-filters

                $svg.setAttribute('color-interpolation-filters', 'sRGB');
                _this.$camera = createSVGElement('g');
                _this.$camera.id = G_SVG_PREFIX + "_camera";

                _this.applyTransform(_this.$camera, _this.camera.getOrthoMatrix());

                $svg.appendChild(_this.$camera);

                _this.renderingContext.root.addEventListener(g.ElementEvent.MOUNTED, handleMounted);

                _this.renderingContext.root.addEventListener(g.ElementEvent.UNMOUNTED, handleUnmounted);

                _this.renderingContext.root.addEventListener(g.ElementEvent.ATTR_MODIFIED, handleAttributeChanged);

              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      })));
      renderingService.hooks.destroy.tap(SVGRendererPlugin_1.tag, function () {
        _this.renderingContext.root.removeEventListener(g.ElementEvent.MOUNTED, handleMounted);

        _this.renderingContext.root.removeEventListener(g.ElementEvent.UNMOUNTED, handleUnmounted);

        _this.renderingContext.root.removeEventListener(g.ElementEvent.ATTR_MODIFIED, handleAttributeChanged);
      });
      renderingService.hooks.render.tap(SVGRendererPlugin_1.tag, function (object) {
        // if (!object.isCulled()) {
        _this.renderQueue.push(object); // }

      });
      renderingService.hooks.endFrame.tap(SVGRendererPlugin_1.tag, function () {
        if (_this.renderingContext.renderReasons.has(g.RenderReason.CAMERA_CHANGED)) {
          _this.applyTransform(_this.$camera, _this.camera.getOrthoMatrix());
        }

        _this.renderQueue.forEach(function (object) {
          var _object$elementSVG, _object$elementSVG2; // @ts-ignore


          var $el = (_object$elementSVG = object.elementSVG) === null || _object$elementSVG === void 0 ? void 0 : _object$elementSVG.$el; // @ts-ignore

          var $groupEl = (_object$elementSVG2 = object.elementSVG) === null || _object$elementSVG2 === void 0 ? void 0 : _object$elementSVG2.$groupEl;

          if ($el && $groupEl) {
            // apply local RTS transformation to <group> wrapper
            // account for anchor
            _this.applyTransform($groupEl, object.getLocalTransform());

            var children = ((object === null || object === void 0 ? void 0 : object.children) || []).slice();

            _this.reorderChildren($groupEl, children || []); // finish rendering, clear dirty flag


            object.renderable.dirty = false;
          }
        });

        _this.renderQueue = [];
      });
    };

    _proto.reorderChildren = function reorderChildren($groupEl, children) {
      // need to reorder parent's children
      children.sort(function (a, b) {
        return a.sortable.renderOrder - b.sortable.renderOrder;
      });

      if (children.length) {
        // create empty fragment
        var fragment = document.createDocumentFragment();
        children.forEach(function (child) {
          // @ts-ignore
          var $el = child.elementSVG.$groupEl;

          if ($el) {
            fragment.appendChild($el);
          }
        });
        $groupEl.appendChild(fragment);
      }
    };

    _proto.applyTransform = function applyTransform($el, transform) {
      var translation = getTranslation(create$1(), transform);
      var scaling = getScaling(create$1(), transform);
      var rotation = getRotation(create$3(), transform);
      var x = translation[0],
          y = translation[1];
      var scaleX = scaling[0],
          scaleY = scaling[1]; // eslint-disable-next-line @typescript-eslint/no-unused-vars

      var _getEuler = g.getEuler(create$1(), rotation),
          ex = _getEuler[0],
          ey = _getEuler[1],
          ez = _getEuler[2]; // gimbal lock at 90 degrees


      var rts = g.fromRotationTranslationScale(ex || ez, x, y, scaleX, scaleY); // use proper precision avoiding too long string in `transform`
      // @see https://developer.mozilla.org/en-US/docs/Web/API/Canvas_API/Tutorial/Transformations

      $el.setAttribute('transform', "matrix(" + numberToLongString(rts[0]) + "," + numberToLongString(rts[1]) + "," + numberToLongString(rts[3]) + "," + numberToLongString(rts[4]) + "," + numberToLongString(rts[6]) + "," + numberToLongString(rts[7]) + ")");
    };

    _proto.applyAttributes = function applyAttributes(object) {
      // @ts-ignore
      var elementSVG = object.elementSVG;
      var $el = elementSVG === null || elementSVG === void 0 ? void 0 : elementSVG.$el;
      var $groupEl = elementSVG === null || elementSVG === void 0 ? void 0 : elementSVG.$groupEl;

      if ($el && $groupEl) {
        var nodeName = object.nodeName,
            attributes = object.attributes;
        $el.setAttribute('fill', 'none');

        if (nodeName === g.Shape.IMAGE) {
          $el.setAttribute('preserveAspectRatio', 'none');
        } // apply attributes


        this.updateAttribute(object, Object.keys(attributes));
      }
    };

    _proto.updateAttribute = function updateAttribute(object, attributes) {
      var _this2 = this;

      var needGeneratePath = false; // @ts-ignore

      var _object$elementSVG3 = object.elementSVG,
          $el = _object$elementSVG3.$el,
          $groupEl = _object$elementSVG3.$groupEl,
          $hitTestingEl = _object$elementSVG3.$hitTestingEl;
      var parsedStyle = object.parsedStyle,
          computedStyle = object.computedStyle;
      var elementRenderer = this.elementRendererFactory(object.nodeName);
      attributes.forEach(function (name) {
        var usedName = SVG_ATTR_MAP[name];
        var computedValue = computedStyle[name];
        var usedValue = parsedStyle[name]; // generate path only once

        if (!needGeneratePath && elementRenderer && elementRenderer.dependencies.indexOf(name) > -1) {
          needGeneratePath = true;
        } // <foreignObject>


        if (object.nodeName === g.Shape.HTML) {
          if (name === 'fill') {
            $el.style.background = usedValue.toString();
          } else if (name === 'stroke') {
            $el.style['border-color'] = usedValue.toString();
            $el.style['border-style'] = 'solid';
          } else if (name === 'lineWidth') {
            $el.style['border-width'] = (usedValue.value || 0) + "px";
          } else if (name === 'lineDash') {
            $el.style['border-style'] = 'dashed';
          }
        }

        if (name === 'fill' || name === 'stroke') {
          createOrUpdateGradientAndPattern(_this2.$def, object, $el, usedValue, usedName);
        } else if (name === 'visibility') {
          // use computed value
          // update `visibility` on <group>
          $groupEl === null || $groupEl === void 0 ? void 0 : $groupEl.setAttribute(usedName, "" + computedValue.value);
        } else if (name === 'clipPath') {
          _this2.createOrUpdateClipPath(usedValue, $groupEl);
        } else if (name === 'shadowColor' || name === 'shadowBlur' || name === 'shadowOffsetX' || name === 'shadowOffsetY') {
          createOrUpdateShadow(_this2.$def, object, $el, name);
        } else if (name === 'filter') {
          createOrUpdateFilter(_this2.$def, object, $el, usedValue);
        } else if (name === 'innerHTML') {
          _this2.createOrUpdateInnerHTML($el, usedValue);
        } else {
          if ( // (!object.style.clipPathTargets) &&
          object.nodeName !== g.Shape.TEXT && // text' anchor is controlled by `textAnchor` property
          ['width', 'height', 'r', 'rx', 'ry', 'anchor'].indexOf(name) > -1) {
            _this2.updateAnchorWithTransform(object);
          }

          if (name !== 'anchor' && computedValue) {
            // use computed value so that we can use cascaded effect in SVG
            var valueStr = computedValue.toString(); // ignore 'unset' and default value

            [$el, $hitTestingEl].forEach(function ($el) {
              if ($el && usedName) {
                if (valueStr !== 'unset' && valueStr !== DEFAULT_VALUE_MAP[name]) {
                  var _FORMAT_VALUE_MAP$nam;

                  var formattedValueStr = ((_FORMAT_VALUE_MAP$nam = FORMAT_VALUE_MAP[name]) === null || _FORMAT_VALUE_MAP$nam === void 0 ? void 0 : _FORMAT_VALUE_MAP$nam[valueStr]) || valueStr;
                  $el.setAttribute(usedName, formattedValueStr);
                } else {
                  $el.removeAttribute(usedName);
                }
              }
            });
          }
        }
      }); // need re-generate path

      if (needGeneratePath && $el) {
        [$el, $hitTestingEl].forEach(function ($el) {
          if ($el) {
            elementRenderer.apply($el, object.parsedStyle);
          }
        });
      }
    };

    _proto.createSVGDom = function createSVGDom(object, root, noWrapWithGroup) {
      if (noWrapWithGroup === void 0) {
        noWrapWithGroup = false;
      } // create svg element
      // @ts-ignore


      object.elementSVG = new ElementSVG(); // @ts-ignore

      var svgElement = object.elementSVG; // use <group> as default, eg. CustomElement

      var type = SHAPE2TAGS[object.nodeName] || 'g';

      if (type) {
        var _object$parentNode$el2;

        var $groupEl;
        var $el = createSVGElement(type); // save $el on parsedStyle, which will be returned in getDomElement()

        if (object.nodeName === g.Shape.HTML) {
          object.parsedStyle.$el = $el;
        }

        $el.id = G_SVG_PREFIX + "_" + object.nodeName + "_" + object.entity;

        if (type !== 'g' && !noWrapWithGroup) {
          $groupEl = createSVGElement('g');
          $groupEl.appendChild($el);
        } else {
          $groupEl = $el;
        }

        svgElement.$el = $el;
        svgElement.$groupEl = $groupEl;
        var $parentGroupEl = // @ts-ignore
        object.parentNode && ((_object$parentNode$el2 = object.parentNode.elementSVG) === null || _object$parentNode$el2 === void 0 ? void 0 : _object$parentNode$el2.$groupEl) || root;

        if ($parentGroupEl) {
          $parentGroupEl.appendChild($groupEl);
        } // apply attributes at first time


        this.applyAttributes(object); // create hitArea if necessary

        this.createOrUpdateHitArea(object, $el, $groupEl);
      }
    };

    _proto.removeSVGDom = function removeSVGDom(object) {
      var _object$elementSVG4; // @ts-ignore


      var $groupEl = (_object$elementSVG4 = object.elementSVG) === null || _object$elementSVG4 === void 0 ? void 0 : _object$elementSVG4.$groupEl;

      if ($groupEl && $groupEl.parentNode) {
        $groupEl.parentNode.removeChild($groupEl); // object.entity.removeComponent(ElementSVG, true);
      }
    };

    _proto.createOrUpdateHitArea = function createOrUpdateHitArea(object, $el, $groupEl) {
      var _object$parsedStyle$i; // @ts-ignore


      var svgElement = object.elementSVG;
      var $hitTestingEl = svgElement.$hitTestingEl;
      var increasedLineWidthForHitTesting = (_object$parsedStyle$i = object.parsedStyle.increasedLineWidthForHitTesting) === null || _object$parsedStyle$i === void 0 ? void 0 : _object$parsedStyle$i.value; // account for hitArea

      if (increasedLineWidthForHitTesting) {
        var _object$parsedStyle$l;

        if (!$hitTestingEl) {
          $hitTestingEl = $el.cloneNode(); // use the entity suffix, so that `g-plugin-svg-picker` can extract

          $hitTestingEl.id = G_SVG_PREFIX + "_" + object.nodeName + "_hittesting_" + object.entity; // clear attributes like `filter` `font-size`

          ['filter'].forEach(function (attribute) {
            $hitTestingEl.removeAttribute(attribute);
          }); // hitArea should be 'transparent' but not 'none'

          var hasFill = $el.getAttribute('fill') !== 'none';
          $hitTestingEl.setAttribute('fill', hasFill ? 'transparent' : 'none');
          $hitTestingEl.setAttribute('stroke', 'transparent');
          $groupEl.appendChild($hitTestingEl);
          svgElement.$hitTestingEl = $hitTestingEl;
        } // increase interactive line width


        $hitTestingEl.setAttribute('stroke-width', "" + (increasedLineWidthForHitTesting + ((_object$parsedStyle$l = object.parsedStyle.lineWidth) === null || _object$parsedStyle$l === void 0 ? void 0 : _object$parsedStyle$l.value)));
      } else {
        if ($hitTestingEl) {
          $groupEl.removeChild($hitTestingEl);
          svgElement.$hitTestingEl = null;
        }
      }
    };

    _proto.createOrUpdateInnerHTML = function createOrUpdateInnerHTML($el, usedValue) {
      var $div = document.createElement('div');

      if (typeof usedValue === 'string') {
        $div.innerHTML = usedValue;
      } else {
        $div.appendChild(usedValue);
      }

      $el.innerHTML = '';
      $el.appendChild($div);
    };

    _proto.createOrUpdateClipPath = function createOrUpdateClipPath(clipPath, $groupEl) {
      if (clipPath) {
        var _clipPath$elementSVG;

        var clipPathId = CLIP_PATH_PREFIX + clipPath.entity;
        var existed = this.$def.querySelector("#" + clipPathId);

        if (!existed) {
          // create <clipPath> dom node, append it to <defs>
          var $clipPath = createSVGElement('clipPath');
          $clipPath.id = clipPathId;
          this.$def.appendChild($clipPath); // <clipPath><circle /></clipPath>

          this.createSVGDom(clipPath, $clipPath, true); // @ts-ignore

          clipPath.elementSVG.$groupEl = $clipPath;
        } // @ts-ignore


        var $clipPathGroupEl = (_clipPath$elementSVG = clipPath.elementSVG) === null || _clipPath$elementSVG === void 0 ? void 0 : _clipPath$elementSVG.$groupEl;

        if ($clipPathGroupEl) {
          // apply local RTS transformation to <group> wrapper
          this.applyTransform($clipPathGroupEl, clipPath.getLocalTransform());
        } // apply attributes


        this.applyAttributes(clipPath); // apply clipPath to $group
        // @see https://github.com/antvis/g/issues/961

        $groupEl.setAttribute('clip-path', "url(#" + clipPathId + ")");
      } else {
        // remove clip path
        $groupEl.removeAttribute('clip-path');
      }
    }
    /**
     * the origin is bounding box's top left corner
     */
    ;

    _proto.updateAnchorWithTransform = function updateAnchorWithTransform(object) {
      var _object$elementSVG5, _object$elementSVG6;

      var bounds = object.getGeometryBounds();
      var width = bounds && bounds.halfExtents[0] * 2 || 0;
      var height = bounds && bounds.halfExtents[1] * 2 || 0;

      var _ref2 = object.parsedStyle || {},
          anchor = _ref2.anchor; // @ts-ignore


      [(_object$elementSVG5 = object.elementSVG) === null || _object$elementSVG5 === void 0 ? void 0 : _object$elementSVG5.$el, (_object$elementSVG6 = object.elementSVG) === null || _object$elementSVG6 === void 0 ? void 0 : _object$elementSVG6.$hitTestingEl].forEach(function ($el) {
        if ($el) {
          // apply anchor to element's `transform` property
          $el.setAttribute('transform', // can't use percent unit like translate(-50%, -50%)
          // @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Attribute/transform#translate
          "translate(-" + anchor[0].value * width + ",-" + anchor[1].value * height + ")");

          if (object.nodeName === g.Shape.CIRCLE || object.nodeName === g.Shape.ELLIPSE) {
            $el.setAttribute('cx', "" + width / 2);
            $el.setAttribute('cy', "" + height / 2);
          }
        }
      });
    };

    return SVGRendererPlugin;
  }(), _class$1.tag = 'SVGRenderer', _class$1);

  __decorate([manaSyringe.inject(g.CanvasConfig), __metadata("design:type", Object)], SVGRendererPlugin.prototype, "canvasConfig", void 0);

  __decorate([manaSyringe.inject(g.DefaultCamera), __metadata("design:type", g.Camera)], SVGRendererPlugin.prototype, "camera", void 0);

  __decorate([manaSyringe.inject(g.ContextService), __metadata("design:type", Object)], SVGRendererPlugin.prototype, "contextService", void 0);

  __decorate([manaSyringe.inject(g.RenderingContext), __metadata("design:type", Object)], SVGRendererPlugin.prototype, "renderingContext", void 0);

  __decorate([manaSyringe.inject(ElementRendererFactory), __metadata("design:type", Function)], SVGRendererPlugin.prototype, "elementRendererFactory", void 0);

  SVGRendererPlugin = SVGRendererPlugin_1 = __decorate([manaSyringe.singleton({
    contrib: g.RenderingPluginContribution
  })], SVGRendererPlugin);
  var containerModule$1 = manaSyringe.Module(function (register) {
    /**
     * register shape renderers
     */
    register(RectRenderer);
    register(ImageRenderer);
    register(LineRenderer);
    register(PolylineRenderer);
    register(TextRenderer);
    register(PathRenderer);
    register({
      token: ElementRendererFactory,
      useFactory: function useFactory(ctx) {
        return function (tagName) {
          if (tagName === g.Shape.RECT) {
            return ctx.container.get(RectRenderer);
          } else if (tagName === g.Shape.IMAGE) {
            return ctx.container.get(ImageRenderer);
          } else if (tagName === g.Shape.LINE) {
            return ctx.container.get(LineRenderer);
          } else if (tagName === g.Shape.POLYLINE || tagName === g.Shape.POLYGON) {
            return ctx.container.get(PolylineRenderer);
          } else if (tagName === g.Shape.TEXT) {
            return ctx.container.get(TextRenderer);
          } else if (tagName === g.Shape.PATH) {
            return ctx.container.get(PathRenderer);
          }

          return null;
        };
      }
    });
    register(SVGRendererPlugin);
  });

  var Plugin$1 = /*#__PURE__*/function () {
    function Plugin() {
      this.name = 'svg-renderer';
    }

    var _proto = Plugin.prototype;

    _proto.init = function init(container) {
      container.load(containerModule$1, true);
    };

    _proto.destroy = function destroy(container) {
      container.unload(containerModule$1);
    };

    return Plugin;
  }();

  var index_esm$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    DEFAULT_VALUE_MAP: DEFAULT_VALUE_MAP,
    ElementSVG: ElementSVG,
    G_SVG_PREFIX: G_SVG_PREFIX,
    Plugin: Plugin$1,
    SHAPE2TAGS: SHAPE2TAGS,
    get SVGRendererPlugin () { return SVGRendererPlugin; },
    SVG_ATTR_MAP: SVG_ATTR_MAP,
    containerModule: containerModule$1,
    createSVGElement: createSVGElement
  });

  function _regeneratorRuntime$2() {
    /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */
    _regeneratorRuntime$2 = function _regeneratorRuntime() {
      return exports;
    };

    var exports = {},
        Op = Object.prototype,
        hasOwn = Op.hasOwnProperty,
        $Symbol = "function" == typeof Symbol ? Symbol : {},
        iteratorSymbol = $Symbol.iterator || "@@iterator",
        asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
        toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      return Object.defineProperty(obj, key, {
        value: value,
        enumerable: !0,
        configurable: !0,
        writable: !0
      }), obj[key];
    }

    try {
      define({}, "");
    } catch (err) {
      define = function define(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
          generator = Object.create(protoGenerator.prototype),
          context = new Context(tryLocsList || []);
      return generator._invoke = function (innerFn, self, context) {
        var state = "suspendedStart";
        return function (method, arg) {
          if ("executing" === state) throw new Error("Generator is already running");

          if ("completed" === state) {
            if ("throw" === method) throw arg;
            return doneResult();
          }

          for (context.method = method, context.arg = arg;;) {
            var delegate = context.delegate;

            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context);

              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue;
                return delegateResult;
              }
            }

            if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
              if ("suspendedStart" === state) throw state = "completed", context.arg;
              context.dispatchException(context.arg);
            } else "return" === context.method && context.abrupt("return", context.arg);
            state = "executing";
            var record = tryCatch(innerFn, self, context);

            if ("normal" === record.type) {
              if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
              return {
                value: record.arg,
                done: context.done
              };
            }

            "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
          }
        };
      }(innerFn, self, context), generator;
    }

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    exports.wrap = wrap;
    var ContinueSentinel = {};

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {}

    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });
    var getProto = Object.getPrototypeOf,
        NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if ("throw" !== record.type) {
          var result = record.arg,
              value = result.value;
          return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          }) : PromiseImpl.resolve(value).then(function (unwrapped) {
            result.value = unwrapped, resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }

        reject(record.arg);
      }

      var previousPromise;

      this._invoke = function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      };
    }

    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (undefined === method) {
        if (context.delegate = null, "throw" === context.method) {
          if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
          context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);
      if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
      var info = record.arg;
      return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
    }

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };
      1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal", delete record.arg, entry.completion = record;
    }

    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
    }

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) return iteratorMethod.call(iterable);
        if ("function" == typeof iterable.next) return iterable;

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            for (; ++i < iterable.length;) {
              if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            }

            return next.value = undefined, next.done = !0, next;
          };

          return next.next = next;
        }
      }

      return {
        next: doneResult
      };
    }

    function doneResult() {
      return {
        value: undefined,
        done: !0
      };
    }

    return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
      var ctor = "function" == typeof genFun && genFun.constructor;
      return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
    }, exports.mark = function (genFun) {
      return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
    }, exports.awrap = function (arg) {
      return {
        __await: arg
      };
    }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      void 0 === PromiseImpl && (PromiseImpl = Promise);
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
      return this;
    }), define(Gp, "toString", function () {
      return "[object Generator]";
    }), exports.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      return keys.reverse(), function next() {
        for (; keys.length;) {
          var key = keys.pop();
          if (key in object) return next.value = key, next.done = !1, next;
        }

        return next.done = !0, next;
      };
    }, exports.values = values, Context.prototype = {
      constructor: Context,
      reset: function reset(skipTempReset) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) {
          "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
        }
      },
      stop: function stop() {
        this.done = !0;
        var rootRecord = this.tryEntries[0].completion;
        if ("throw" === rootRecord.type) throw rootRecord.arg;
        return this.rval;
      },
      dispatchException: function dispatchException(exception) {
        if (this.done) throw exception;
        var context = this;

        function handle(loc, caught) {
          return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i],
              record = entry.completion;
          if ("root" === entry.tryLoc) return handle("end");

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc"),
                hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            } else {
              if (!hasFinally) throw new Error("try statement without catch or finally");
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            }
          }
        }
      },
      abrupt: function abrupt(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
        var record = finallyEntry ? finallyEntry.completion : {};
        return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
      },
      complete: function complete(record, afterLoc) {
        if ("throw" === record.type) throw record.arg;
        return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
      },
      finish: function finish(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
        }
      },
      catch: function _catch(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if ("throw" === record.type) {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        }

        throw new Error("illegal catch attempt");
      },
      delegateYield: function delegateYield(iterable, resultName, nextLoc) {
        return this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
      }
    }, exports;
  }

  function asyncGeneratorStep$2(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator$2(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep$2(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep$2(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  }

  function _createForOfIteratorHelperLoose(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (it) return (it = it.call(o)).next.bind(it);

    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      return function () {
        if (i >= o.length) return {
          done: true
        };
        return {
          done: false,
          value: o[i++]
        };
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var _class$2;

  var SVGPickerPlugin_1;
  /**
   * pick shape(s) with Mouse/Touch event
   *
   * 1. find AABB with r-tree
   * 2. use elementFromPoint
   */

  var SVGPickerPlugin = SVGPickerPlugin_1 = (_class$2 = /*#__PURE__*/function () {
    function SVGPickerPlugin() {
      this.sceneGraphService = void 0;
      this.displayObjectPool = void 0;
    }

    var _proto = SVGPickerPlugin.prototype;

    _proto.apply = function apply(renderingService) {
      var _this = this;

      renderingService.hooks.pick.tapPromise(SVGPickerPlugin_1.tag, /*#__PURE__*/function () {
        var _ref = _asyncToGenerator$2( /*#__PURE__*/_regeneratorRuntime$2().mark(function _callee(result) {
          var topmost, _result$position, clientX, clientY, targets, _iterator, _step, element, id, index, target;

          return _regeneratorRuntime$2().wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  topmost = result.topmost, _result$position = result.position, clientX = _result$position.clientX, clientY = _result$position.clientY;
                  _context.prev = 1;
                  targets = []; // @see https://developer.mozilla.org/zh-CN/docs/Web/API/Document/elementsFromPoint

                  _iterator = _createForOfIteratorHelperLoose(document.elementsFromPoint(clientX, clientY));

                case 4:
                  if ((_step = _iterator()).done) {
                    _context.next = 17;
                    break;
                  }

                  element = _step.value; // eg. g_svg_circle_345

                  id = element && element.getAttribute('id');

                  if (!(id && id.startsWith(G_SVG_PREFIX))) {
                    _context.next = 15;
                    break;
                  }

                  index = id.lastIndexOf('_');
                  target = _this.displayObjectPool.getByEntity(Number(id.substring(index + 1))); // don't need to account for `visibility` since DOM API already does

                  if (!(target && target.isInteractive())) {
                    _context.next = 15;
                    break;
                  }

                  targets.push(target);

                  if (!topmost) {
                    _context.next = 15;
                    break;
                  }

                  result.picked = targets;
                  return _context.abrupt("return", result);

                case 15:
                  _context.next = 4;
                  break;

                case 17:
                  result.picked = targets;
                  _context.next = 23;
                  break;

                case 20:
                  _context.prev = 20;
                  _context.t0 = _context["catch"](1);
                  result.picked = [];

                case 23:
                  return _context.abrupt("return", result);

                case 24:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[1, 20]]);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    };

    return SVGPickerPlugin;
  }(), _class$2.tag = 'SVGPicker', _class$2);

  __decorate([manaSyringe.inject(g.SceneGraphService), __metadata("design:type", Object)], SVGPickerPlugin.prototype, "sceneGraphService", void 0);

  __decorate([manaSyringe.inject(g.DisplayObjectPool), __metadata("design:type", g.DisplayObjectPool)], SVGPickerPlugin.prototype, "displayObjectPool", void 0);

  SVGPickerPlugin = SVGPickerPlugin_1 = __decorate([manaSyringe.singleton({
    contrib: g.RenderingPluginContribution
  })], SVGPickerPlugin);
  var containerModule$2 = manaSyringe.Module(function (register) {
    register(SVGPickerPlugin);
  });

  var Plugin$2 = /*#__PURE__*/function () {
    function Plugin() {
      this.name = 'svg-picker';
    }

    var _proto = Plugin.prototype;

    _proto.init = function init(container) {
      container.load(containerModule$2, true);
    };

    _proto.destroy = function destroy(container) {
      container.unload(containerModule$2);
    };

    return Plugin;
  }();

  var index_esm$2 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    Plugin: Plugin$2
  });

  var SVGContextService = /*#__PURE__*/function () {
    function SVGContextService() {
      this.$container = void 0;
      this.$namespace = void 0;
      this.dpr = void 0;
      this.canvasConfig = void 0;
    }

    var _proto = SVGContextService.prototype;

    _proto.init = function init() {
      var container = this.canvasConfig.container; // create container

      this.$container = g.isString(container) ? document.getElementById(container) : container;

      if (this.$container) {
        if (!this.$container.style.position) {
          this.$container.style.position = 'relative';
        }

        var $namespace = createSVGElement('svg');
        $namespace.setAttribute('width', "" + this.canvasConfig.width);
        $namespace.setAttribute('height', "" + this.canvasConfig.height);
        this.$container.appendChild($namespace);
        this.$namespace = $namespace;
      }

      var dpr = window.devicePixelRatio || 1;
      dpr = dpr >= 1 ? Math.ceil(dpr) : 1;
      this.dpr = dpr;
    } // @ts-ignore
    ;

    _proto.getDomElement = function getDomElement() {
      return this.$namespace;
    };

    _proto.getContext = function getContext() {
      return this.$namespace;
    };

    _proto.getDPR = function getDPR() {
      return this.dpr;
    };

    _proto.getBoundingClientRect = function getBoundingClientRect() {
      var _this$$namespace;

      return (_this$$namespace = this.$namespace) === null || _this$$namespace === void 0 ? void 0 : _this$$namespace.getBoundingClientRect();
    };

    _proto.destroy = function destroy() {
      // destroy context
      if (this.$container && this.$namespace && this.$namespace.parentNode) {
        this.$container.removeChild(this.$namespace);
      }
    };

    _proto.resize = function resize(width, height) {
      if (this.$namespace) {
        this.$namespace.setAttribute('width', "" + width);
        this.$namespace.setAttribute('height', "" + height);
      }
    };

    _proto.applyCursorStyle = function applyCursorStyle(cursor) {
      if (this.$container) {
        this.$container.style.cursor = cursor;
      }
    };

    return SVGContextService;
  }();

  __decorate([manaSyringe.inject(g.CanvasConfig), __metadata("design:type", Object)], SVGContextService.prototype, "canvasConfig", void 0);

  SVGContextService = __decorate([manaSyringe.singleton({
    token: g.ContextService
  })], SVGContextService);

  var containerModule$3 = manaSyringe.Module(function (register) {
    /**
     * implements ContextService
     */
    register(SVGContextService);
  });
  var ContextRegisterPlugin = /*#__PURE__*/function () {
    function ContextRegisterPlugin() {
      this.name = 'svg-context-register';
    }

    var _proto = ContextRegisterPlugin.prototype;

    _proto.init = function init(container) {
      container.load(containerModule$3, true);
    };

    _proto.destroy = function destroy(container) {
      container.unload(containerModule$3);
    };

    return ContextRegisterPlugin;
  }();

  var Renderer = /*#__PURE__*/function (_AbstractRenderer) {
    _inheritsLoose(Renderer, _AbstractRenderer);

    function Renderer(config) {
      var _this;

      _this = _AbstractRenderer.call(this, config) || this;

      _this.registerPlugin(new ContextRegisterPlugin());

      _this.registerPlugin(new Plugin$1());

      _this.registerPlugin(new Plugin());

      _this.registerPlugin(new Plugin$2());

      return _this;
    }

    return Renderer;
  }(g.AbstractRenderer);

  exports.DomInteraction = index_esm;
  exports.Renderer = Renderer;
  exports.SVGPicker = index_esm$2;
  exports.SVGRenderer = index_esm$1;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
